/*
 * linux/sound/soc/codecs/first_rate_pps_driver.h
 *
 *
 * Copyright (C) 2011 Texas Instruments, Inc.
 *
 * This package is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * THIS PACKAGE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
*/

static control main44_MUX_controls[] = {
	{80, 1, 28, 1, 0},
	{40, 3, 120, 1, 1}
};

static char *main44_MUX_control_names[] = {
	"Stereo_Mux_TwoToOne_1",
	"Mono_Mux_1_1"
};

static control main44_VOLUME_controls[] = {
	/*{80, 1, 32, 0, 0}*/
};

static char *main44_VOLUME_control_names[] = {
	/*"Volume_1"*/
};

/*INSTRUCTIONS & COEFFICIENTS*/
/*typedef struct {
	u8 reg_off;
	u8 reg_val;
} reg_value;*/

static char *REG_Section_names[] = {
	"main44_miniDSP_A_reg_values",
	"main44_miniDSP_D_reg_values",
};

reg_value main44_REG_Section_init_program[] = {
	{  0, 0x0},
	{  0x7F, 0x00},
/*	# Set AutoINC */
	{121, 0x01},
/*# reg[0][1][122] = 0x01; reg(0)(1)(0x7A => 122)    Vref charge time - 40 ms.*/
	{122, 0x01},
};


reg_value main44_REG_Section_post_program[] = {
	{  0, 0x0},
	{  0x7F, 0x28},
/*# reg[40][0][1] = 0x04; adaptive mode for ADC */
	{  1, 0x04},
	{  0x7F, 0x50},
/*# reg[80][0][1] = 0x04; adaptive mode for DAC */
	{  1, 0x04},
	{  0x7F, 0x64},
/*# reg[100][0][48] = 4; IDAC  = 256; MDAC*DOSR;IADC  = 256;
MADC*AOSR;IDAC  = 512    ; MDAC*DOSR;IADC  = 512; MADC*AOSR;IDAC  = 1024;
MDAC*DOSR;IADC  = 1024    ; MADC*AOSR;IDAC  = 1536; MDAC*DOSR;IADC  = 1536;
MADC*AOSR;IDAC  = 2048    ; MDAC*DOSR;IADC  = 2048; MADC*AOSR;IDAC  = 3072;
MDAC*DOSR;IADC  = 3072   ; MADC*AOSR;IDAC  = 4096; MDAC*DOSR;IADC  = 4096;
MADC*AOSR;IDAC  = 6144    ; MDAC*DOSR;IADC  = 6144   ; MADC*AOSR */
	{ 48, 0x04},
/* # reg[100][0][49] = 0*/
	{ 49, 0x00},
	{  0x7F, 0x78},
/*# reg[120][0][48] = 4 */
	{ 48, 0x04},
/*# reg[120][0][49] = 0*/
	{ 49, 0x00},
	{  0x7F, 0x00},
};


reg_value main44_miniDSP_A_reg_values[] = {
	{  0, 0x0},
	{  0x7F, 0x28},
	{  0, 0x01},
	{  8, 0x00},
	{  9, 0xA7},
	{ 10, 0xF8},
	{ 11, 0x00},
	{ 12, 0x7E},
	{ 13, 0xB0},
	{ 14, 0x10},
	{ 15, 0x00},
	{ 16, 0x7F},
	{ 17, 0xFF},
	{ 18, 0xFF},
	{ 19, 0x00},
	{ 20, 0x00},
	{ 21, 0x00},
	{ 22, 0x00},
	{ 23, 0x00},
	{ 24, 0x00},
	{ 25, 0x00},
	{ 26, 0x00},
	{ 27, 0x00},
	{ 28, 0x20},
	{ 29, 0x26},
	{ 30, 0x00},
	{ 31, 0x00},
	{ 32, 0x20},
	{ 33, 0x00},
	{ 34, 0x00},
	{ 35, 0x00},
	{ 36, 0x01},
	{ 37, 0x58},
	{ 38, 0x00},
	{ 39, 0x00},
	{ 40, 0xFE},
	{ 41, 0xA8},
	{ 42, 0x00},
	{ 43, 0x00},
	{ 44, 0x7E},
	{ 45, 0x89},
	{ 46, 0x00},
	{ 47, 0x00},
	{ 48, 0x82},
	{ 49, 0xB2},
	{ 50, 0x00},
	{ 51, 0x00},
	{ 52, 0x01},
	{ 53, 0xE5},
	{ 54, 0x00},
	{ 55, 0x00},
	{ 56, 0xFE},
	{ 57, 0x1B},
	{ 58, 0x00},
	{ 59, 0x00},
	{ 60, 0x7D},
	{ 61, 0xDF},
	{ 62, 0x00},
	{ 63, 0x00},
	{ 64, 0x83},
	{ 65, 0xCC},
	{ 66, 0x00},
	{ 67, 0x00},
	{ 68, 0x02},
	{ 69, 0xAA},
	{ 70, 0x00},
	{ 71, 0x00},
	{ 72, 0xFD},
	{ 73, 0x56},
	{ 74, 0x00},
	{ 75, 0x00},
	{ 76, 0x7C},
	{ 77, 0xE0},
	{ 78, 0x00},
	{ 79, 0x00},
	{ 80, 0x85},
	{ 81, 0x55},
	{ 82, 0x00},
	{ 83, 0x00},
	{ 84, 0x03},
	{ 85, 0xBB},
	{ 86, 0x00},
	{ 87, 0x00},
	{ 88, 0xFC},
	{ 89, 0x45},
	{ 90, 0x00},
	{ 91, 0x00},
	{ 92, 0x7B},
	{ 93, 0x5B},
	{ 94, 0x00},
	{ 95, 0x00},
	{ 96, 0x87},
	{ 97, 0x78},
	{ 98, 0x00},
	{ 99, 0x00},
	{100, 0x05},
	{101, 0x34},
	{102, 0x00},
	{103, 0x00},
	{104, 0xFA},
	{105, 0xCC},
	{106, 0x00},
	{107, 0x00},
	{108, 0x78},
	{109, 0xFF},
	{110, 0x00},
	{111, 0x00},
	{112, 0x8A},
	{113, 0x6A},
	{114, 0x00},
	{115, 0x00},
	{116, 0x07},
	{117, 0x35},
	{118, 0x00},
	{119, 0x00},
	{120, 0xF8},
	{121, 0xCB},
	{122, 0x00},
	{123, 0x00},
	{124, 0x75},
	{125, 0x44},
	{126, 0x00},
	{127, 0x00},
	{  0, 0x02},
	{  8, 0x8E},
	{  9, 0x6C},
	{ 10, 0x00},
	{ 11, 0x00},
	{ 12, 0x09},
	{ 13, 0xE0},
	{ 14, 0x00},
	{ 15, 0x00},
	{ 16, 0xF6},
	{ 17, 0x20},
	{ 18, 0x00},
	{ 19, 0x00},
	{ 20, 0x6F},
	{ 21, 0x43},
	{ 22, 0x00},
	{ 23, 0x00},
	{ 24, 0x93},
	{ 25, 0xC1},
	{ 26, 0x00},
	{ 27, 0x00},
	{ 28, 0x0D},
	{ 29, 0x4C},
	{ 30, 0x00},
	{ 31, 0x00},
	{ 32, 0xF2},
	{ 33, 0xB4},
	{ 34, 0x00},
	{ 35, 0x00},
	{ 36, 0x65},
	{ 37, 0x81},
	{ 38, 0x00},
	{ 39, 0x00},
	{ 40, 0x9A},
	{ 41, 0x9A},
	{ 42, 0x00},
	{ 43, 0x00},
	{ 44, 0xFF},
	{ 45, 0xFF},
	{ 46, 0xFF},
	{ 47, 0x00},
	{ 48, 0x80},
	{ 49, 0x00},
	{ 50, 0x00},
	{ 51, 0x00},
	{ 52, 0x7F},
	{ 53, 0xFF},
	{ 54, 0xFF},
	{ 55, 0x00},
	{ 56, 0x40},
	{ 57, 0x00},
	{ 58, 0x00},
	{ 59, 0x00},
	{ 60, 0x00},
	{ 61, 0x00},
	{ 62, 0x00},
	{ 63, 0x00},
	{ 64, 0xFF},
	{ 65, 0x9E},
	{ 66, 0x00},
	{ 67, 0x00},
	{ 68, 0xF7},
	{ 69, 0x10},
	{ 70, 0x00},
	{ 71, 0x00},
	{ 72, 0x26},
	{ 73, 0xF0},
	{ 74, 0x00},
	{ 75, 0x00},
	{ 76, 0x02},
	{ 77, 0x61},
	{ 78, 0x00},
	{ 79, 0x00},
	{ 80, 0x40},
	{ 81, 0x02},
	{ 82, 0x00},
	{ 83, 0x00},
	{ 84, 0xFF},
	{ 85, 0xFC},
	{ 86, 0x00},
	{ 87, 0x00},
	{ 88, 0xFF},
	{ 89, 0xFD},
	{ 90, 0x00},
	{ 91, 0x00},
	{ 92, 0xFF},
	{ 93, 0xE5},
	{ 94, 0x00},
	{ 95, 0x00},
	{ 96, 0xFF},
	{ 97, 0xA7},
	{ 98, 0x00},
	{ 99, 0x00},
	{100, 0xFF},
	{101, 0xC7},
	{102, 0x00},
	{103, 0x00},
	{104, 0xFF},
	{105, 0xCE},
	{106, 0x00},
	{107, 0x00},
	{108, 0xFF},
	{109, 0xFE},
	{110, 0x00},
	{111, 0x00},
	{112, 0xFE},
	{113, 0xF7},
	{114, 0x00},
	{115, 0x00},
	{116, 0xFF},
	{117, 0x46},
	{118, 0x00},
	{119, 0x00},
	{120, 0xFF},
	{121, 0x22},
	{122, 0x00},
	{123, 0x00},
	{124, 0xFF},
	{125, 0x0F},
	{126, 0x00},
	{127, 0x00},
	{  0, 0x03},
	{  8, 0xFA},
	{  9, 0x8C},
	{ 10, 0x00},
	{ 11, 0x00},
	{ 12, 0xF5},
	{ 13, 0x08},
	{ 14, 0x00},
	{ 15, 0x00},
	{ 16, 0xFD},
	{ 17, 0x92},
	{ 18, 0x00},
	{ 19, 0x00},
	{ 20, 0xF3},
	{ 21, 0xA3},
	{ 22, 0x00},
	{ 23, 0x00},
	{ 24, 0x03},
	{ 25, 0xB3},
	{ 26, 0x00},
	{ 27, 0x00},
	{ 28, 0x00},
	{ 29, 0x33},
	{ 30, 0x00},
	{ 31, 0x00},
	{ 32, 0x00},
	{ 33, 0x71},
	{ 34, 0x00},
	{ 35, 0x00},
	{ 36, 0x40},
	{ 37, 0x60},
	{ 38, 0x00},
	{ 39, 0x00},
	{ 40, 0x00},
	{ 41, 0xE2},
	{ 42, 0x00},
	{ 43, 0x00},
	{ 44, 0x00},
	{ 45, 0xC6},
	{ 46, 0x00},
	{ 47, 0x00},
	{ 48, 0x00},
	{ 49, 0x87},
	{ 50, 0x00},
	{ 51, 0x00},
	{ 52, 0x00},
	{ 53, 0x0F},
	{ 54, 0x00},
	{ 55, 0x00},
	{ 56, 0x00},
	{ 57, 0x0A},
	{ 58, 0x00},
	{ 59, 0x00},
	{ 60, 0x00},
	{ 61, 0x02},
	{ 62, 0x00},
	{ 63, 0x00},
	{ 64, 0x01},
	{ 65, 0x81},
	{ 66, 0x00},
	{ 67, 0x00},
	{ 68, 0x18},
	{ 69, 0x89},
	{ 70, 0x00},
	{ 71, 0x00},
	{ 72, 0x07},
	{ 73, 0xFB},
	{ 74, 0x00},
	{ 75, 0x00},
	{ 76, 0x03},
	{ 77, 0xBE},
	{ 78, 0x00},
	{ 79, 0x00},
	{ 80, 0xC0},
	{ 81, 0x00},
	{ 82, 0x00},
	{ 83, 0x00},
	{ 84, 0x80},
	{ 85, 0x04},
	{ 86, 0x00},
	{ 87, 0x00},
	{ 88, 0x00},
	{ 89, 0x00},
	{ 90, 0x00},
	{ 91, 0x00},
	{ 92, 0x7F},
	{ 93, 0x12},
	{ 94, 0x3A},
	{ 95, 0x00},
	{ 96, 0x40},
	{ 97, 0x00},
	{ 98, 0x04},
	{ 99, 0x00},
	{100, 0x00},
	{101, 0x00},
	{102, 0x08},
	{103, 0x00},
	{104, 0x0C},
	{105, 0xCC},
	{106, 0xCD},
	{107, 0x00},
	{108, 0x01},
	{109, 0x47},
	{110, 0xAE},
	{111, 0x00},
	{112, 0x02},
	{113, 0x52},
	{114, 0x6E},
	{115, 0x00},
	{116, 0x00},
	{117, 0x08},
	{118, 0x00},
	{119, 0x00},
	{120, 0x00},
	{121, 0x00},
	{122, 0x01},
	{123, 0x00},
	{124, 0x7F},
	{125, 0xF8},
	{126, 0x00},
	{127, 0x00},
	{  0, 0x04},
	{  8, 0x0C},
	{  9, 0xCC},
	{ 10, 0xCD},
	{ 11, 0x00},
	{ 12, 0x73},
	{ 13, 0x33},
	{ 14, 0x33},
	{ 15, 0x00},
	{ 16, 0x00},
	{ 17, 0xA3},
	{ 18, 0xD7},
	{ 19, 0x00},
	{ 20, 0x00},
	{ 21, 0x00},
	{ 22, 0x00},
	{ 23, 0x00},
	{ 24, 0x00},
	{ 25, 0x00},
	{ 26, 0x00},
	{ 27, 0x00},
	{ 28, 0x00},
	{ 29, 0x00},
	{ 30, 0x00},
	{ 31, 0x00},
	{ 32, 0x00},
	{ 33, 0x00},
	{ 34, 0x00},
	{ 35, 0x00},
	{ 36, 0x00},
	{ 37, 0x00},
	{ 38, 0x00},
	{ 39, 0x00},
	{ 40, 0x00},
	{ 41, 0x00},
	{ 42, 0x00},
	{ 43, 0x00},
	{ 44, 0x00},
	{ 45, 0x00},
	{ 46, 0x00},
	{ 47, 0x00},
	{ 48, 0x00},
	{ 49, 0x00},
	{ 50, 0x00},
	{ 51, 0x00},
	{ 52, 0x00},
	{ 53, 0x00},
	{ 54, 0x00},
	{ 55, 0x00},
	{ 56, 0x00},
	{ 57, 0x00},
	{ 58, 0x00},
	{ 59, 0x00},
	{ 60, 0x00},
	{ 61, 0x00},
	{ 62, 0x00},
	{ 63, 0x00},
	{ 64, 0x00},
	{ 65, 0x00},
	{ 66, 0x00},
	{ 67, 0x00},
	{ 68, 0x00},
	{ 69, 0x00},
	{ 70, 0x00},
	{ 71, 0x00},
	{ 72, 0x00},
	{ 73, 0x00},
	{ 74, 0x00},
	{ 75, 0x00},
	{ 76, 0x00},
	{ 77, 0x00},
	{ 78, 0x00},
	{ 79, 0x00},
	{ 80, 0x00},
	{ 81, 0x00},
	{ 82, 0x00},
	{ 83, 0x00},
	{ 84, 0x00},
	{ 85, 0x00},
	{ 86, 0x00},
	{ 87, 0x00},
	{ 88, 0x00},
	{ 89, 0x00},
	{ 90, 0x00},
	{ 91, 0x00},
	{ 92, 0x00},
	{ 93, 0x00},
	{ 94, 0x00},
	{ 95, 0x00},
	{ 96, 0x00},
	{ 97, 0x00},
	{ 98, 0x00},
	{ 99, 0x00},
	{100, 0x00},
	{101, 0x00},
	{102, 0x00},
	{103, 0x00},
	{104, 0x00},
	{105, 0x00},
	{106, 0x00},
	{107, 0x00},
	{108, 0x00},
	{109, 0x00},
	{110, 0x00},
	{111, 0x00},
	{112, 0x00},
	{113, 0x00},
	{114, 0x00},
	{115, 0x00},
	{  0, 0x09},
	{ 72, 0x00},
	{ 73, 0xA7},
	{ 74, 0xF8},
	{ 75, 0x00},
	{ 76, 0x7E},
	{ 77, 0xB0},
	{ 78, 0x10},
	{ 79, 0x00},
	{ 80, 0x7F},
	{ 81, 0xFF},
	{ 82, 0xFF},
	{ 83, 0x00},
	{ 84, 0x00},
	{ 85, 0x00},
	{ 86, 0x00},
	{ 87, 0x00},
	{ 88, 0x00},
	{ 89, 0x00},
	{ 90, 0x00},
	{ 91, 0x00},
	{ 92, 0x20},
	{ 93, 0x26},
	{ 94, 0x00},
	{ 95, 0x00},
	{ 96, 0x20},
	{ 97, 0x00},
	{ 98, 0x00},
	{ 99, 0x00},
	{100, 0x01},
	{101, 0x58},
	{102, 0x00},
	{103, 0x00},
	{104, 0xFE},
	{105, 0xA8},
	{106, 0x00},
	{107, 0x00},
	{108, 0x7E},
	{109, 0x89},
	{110, 0x00},
	{111, 0x00},
	{112, 0x82},
	{113, 0xB2},
	{114, 0x00},
	{115, 0x00},
	{116, 0x01},
	{117, 0xE5},
	{118, 0x00},
	{119, 0x00},
	{120, 0xFE},
	{121, 0x1B},
	{122, 0x00},
	{123, 0x00},
	{124, 0x7D},
	{125, 0xDF},
	{126, 0x00},
	{127, 0x00},
	{  0, 0x0A},
	{  8, 0x83},
	{  9, 0xCC},
	{ 10, 0x00},
	{ 11, 0x00},
	{ 12, 0x02},
	{ 13, 0xAA},
	{ 14, 0x00},
	{ 15, 0x00},
	{ 16, 0xFD},
	{ 17, 0x56},
	{ 18, 0x00},
	{ 19, 0x00},
	{ 20, 0x7C},
	{ 21, 0xE0},
	{ 22, 0x00},
	{ 23, 0x00},
	{ 24, 0x85},
	{ 25, 0x55},
	{ 26, 0x00},
	{ 27, 0x00},
	{ 28, 0x03},
	{ 29, 0xBB},
	{ 30, 0x00},
	{ 31, 0x00},
	{ 32, 0xFC},
	{ 33, 0x45},
	{ 34, 0x00},
	{ 35, 0x00},
	{ 36, 0x7B},
	{ 37, 0x5B},
	{ 38, 0x00},
	{ 39, 0x00},
	{ 40, 0x87},
	{ 41, 0x78},
	{ 42, 0x00},
	{ 43, 0x00},
	{ 44, 0x05},
	{ 45, 0x34},
	{ 46, 0x00},
	{ 47, 0x00},
	{ 48, 0xFA},
	{ 49, 0xCC},
	{ 50, 0x00},
	{ 51, 0x00},
	{ 52, 0x78},
	{ 53, 0xFF},
	{ 54, 0x00},
	{ 55, 0x00},
	{ 56, 0x8A},
	{ 57, 0x6A},
	{ 58, 0x00},
	{ 59, 0x00},
	{ 60, 0x07},
	{ 61, 0x35},
	{ 62, 0x00},
	{ 63, 0x00},
	{ 64, 0xF8},
	{ 65, 0xCB},
	{ 66, 0x00},
	{ 67, 0x00},
	{ 68, 0x75},
	{ 69, 0x44},
	{ 70, 0x00},
	{ 71, 0x00},
	{ 72, 0x8E},
	{ 73, 0x6C},
	{ 74, 0x00},
	{ 75, 0x00},
	{ 76, 0x09},
	{ 77, 0xE0},
	{ 78, 0x00},
	{ 79, 0x00},
	{ 80, 0xF6},
	{ 81, 0x20},
	{ 82, 0x00},
	{ 83, 0x00},
	{ 84, 0x6F},
	{ 85, 0x43},
	{ 86, 0x00},
	{ 87, 0x00},
	{ 88, 0x93},
	{ 89, 0xC1},
	{ 90, 0x00},
	{ 91, 0x00},
	{ 92, 0x0D},
	{ 93, 0x4C},
	{ 94, 0x00},
	{ 95, 0x00},
	{ 96, 0xF2},
	{ 97, 0xB4},
	{ 98, 0x00},
	{ 99, 0x00},
	{100, 0x65},
	{101, 0x81},
	{102, 0x00},
	{103, 0x00},
	{104, 0x9A},
	{105, 0x9A},
	{106, 0x00},
	{107, 0x00},
	{108, 0xFF},
	{109, 0xFF},
	{110, 0xFF},
	{111, 0x00},
	{112, 0x80},
	{113, 0x00},
	{114, 0x00},
	{115, 0x00},
	{116, 0x7F},
	{117, 0xFF},
	{118, 0xFF},
	{119, 0x00},
	{120, 0x40},
	{121, 0x00},
	{122, 0x00},
	{123, 0x00},
	{124, 0x00},
	{125, 0x00},
	{126, 0x00},
	{127, 0x00},
	{  0, 0x0B},
	{  8, 0xFF},
	{  9, 0x9E},
	{ 10, 0x00},
	{ 11, 0x00},
	{ 12, 0xF7},
	{ 13, 0x10},
	{ 14, 0x00},
	{ 15, 0x00},
	{ 16, 0x26},
	{ 17, 0xF0},
	{ 18, 0x00},
	{ 19, 0x00},
	{ 20, 0x02},
	{ 21, 0x61},
	{ 22, 0x00},
	{ 23, 0x00},
	{ 24, 0x40},
	{ 25, 0x02},
	{ 26, 0x00},
	{ 27, 0x00},
	{ 28, 0xFF},
	{ 29, 0xFC},
	{ 30, 0x00},
	{ 31, 0x00},
	{ 32, 0xFF},
	{ 33, 0xFD},
	{ 34, 0x00},
	{ 35, 0x00},
	{ 36, 0xFF},
	{ 37, 0xE5},
	{ 38, 0x00},
	{ 39, 0x00},
	{ 40, 0xFF},
	{ 41, 0xA7},
	{ 42, 0x00},
	{ 43, 0x00},
	{ 44, 0xFF},
	{ 45, 0xC7},
	{ 46, 0x00},
	{ 47, 0x00},
	{ 48, 0xFF},
	{ 49, 0xCE},
	{ 50, 0x00},
	{ 51, 0x00},
	{ 52, 0xFF},
	{ 53, 0xFE},
	{ 54, 0x00},
	{ 55, 0x00},
	{ 56, 0xFE},
	{ 57, 0xF7},
	{ 58, 0x00},
	{ 59, 0x00},
	{ 60, 0xFF},
	{ 61, 0x46},
	{ 62, 0x00},
	{ 63, 0x00},
	{ 64, 0xFF},
	{ 65, 0x22},
	{ 66, 0x00},
	{ 67, 0x00},
	{ 68, 0xFF},
	{ 69, 0x0F},
	{ 70, 0x00},
	{ 71, 0x00},
	{ 72, 0xFA},
	{ 73, 0x8C},
	{ 74, 0x00},
	{ 75, 0x00},
	{ 76, 0xF5},
	{ 77, 0x08},
	{ 78, 0x00},
	{ 79, 0x00},
	{ 80, 0xFD},
	{ 81, 0x92},
	{ 82, 0x00},
	{ 83, 0x00},
	{ 84, 0xF3},
	{ 85, 0xA3},
	{ 86, 0x00},
	{ 87, 0x00},
	{ 88, 0x03},
	{ 89, 0xB3},
	{ 90, 0x00},
	{ 91, 0x00},
	{ 92, 0x00},
	{ 93, 0x33},
	{ 94, 0x00},
	{ 95, 0x00},
	{ 96, 0x00},
	{ 97, 0x71},
	{ 98, 0x00},
	{ 99, 0x00},
	{100, 0x40},
	{101, 0x60},
	{102, 0x00},
	{103, 0x00},
	{104, 0x00},
	{105, 0xE2},
	{106, 0x00},
	{107, 0x00},
	{108, 0x00},
	{109, 0xC6},
	{110, 0x00},
	{111, 0x00},
	{112, 0x00},
	{113, 0x87},
	{114, 0x00},
	{115, 0x00},
	{116, 0x00},
	{117, 0x0F},
	{118, 0x00},
	{119, 0x00},
	{120, 0x00},
	{121, 0x0A},
	{122, 0x00},
	{123, 0x00},
	{124, 0x00},
	{125, 0x02},
	{126, 0x00},
	{127, 0x00},
	{  0, 0x0C},
	{  8, 0x01},
	{  9, 0x81},
	{ 10, 0x00},
	{ 11, 0x00},
	{ 12, 0x18},
	{ 13, 0x89},
	{ 14, 0x00},
	{ 15, 0x00},
	{ 16, 0x07},
	{ 17, 0xFB},
	{ 18, 0x00},
	{ 19, 0x00},
	{ 20, 0x03},
	{ 21, 0xBE},
	{ 22, 0x00},
	{ 23, 0x00},
	{ 24, 0xC0},
	{ 25, 0x00},
	{ 26, 0x00},
	{ 27, 0x00},

	{ 28, 0x80},
	{ 29, 0x04},
	{ 30, 0x00},
	{ 31, 0x00},
	{ 32, 0x00},
	{ 33, 0x00},
	{ 34, 0x00},
	{ 35, 0x00},
	{ 36, 0x7F},
	{ 37, 0x12},
	{ 38, 0x3A},
	{ 39, 0x00},
	{ 40, 0x40},
	{ 41, 0x00},
	{ 42, 0x04},
	{ 43, 0x00},
	{ 44, 0x00},
	{ 45, 0x00},
	{ 46, 0x08},
	{ 47, 0x00},
	{ 48, 0x0C},
	{ 49, 0xCC},
	{ 50, 0xCD},
	{ 51, 0x00},
	{ 52, 0x01},
	{ 53, 0x47},
	{ 54, 0xAE},
	{ 55, 0x00},
	{ 56, 0x02},
	{ 57, 0x52},
	{ 58, 0x6E},
	{ 59, 0x00},
	{ 60, 0x00},
	{ 61, 0x08},
	{ 62, 0x00},
	{ 63, 0x00},
	{ 64, 0x00},
	{ 65, 0x00},
	{ 66, 0x01},
	{ 67, 0x00},
	{ 68, 0x7F},
	{ 69, 0xF8},
	{ 70, 0x00},
	{ 71, 0x00},
	{ 72, 0x0C},
	{ 73, 0xCC},
	{ 74, 0xCD},
	{ 75, 0x00},
	{ 76, 0x73},
	{ 77, 0x33},
	{ 78, 0x33},
	{ 79, 0x00},
	{ 80, 0x00},
	{ 81, 0xA3},
	{ 82, 0xD7},
	{ 83, 0x00},
	{ 84, 0x00},
	{ 85, 0x00},
	{ 86, 0x00},
	{ 87, 0x00},
	{ 88, 0x00},
	{ 89, 0x00},
	{ 90, 0x00},
	{ 91, 0x00},
	{ 92, 0x00},
	{ 93, 0x00},
	{ 94, 0x00},
	{ 95, 0x00},
	{ 96, 0x00},
	{ 97, 0x00},
	{ 98, 0x00},
	{ 99, 0x00},
	{100, 0x00},
	{101, 0x00},
	{102, 0x00},
	{103, 0x00},
	{104, 0x00},
	{105, 0x00},
	{106, 0x00},
	{107, 0x00},
	{108, 0x00},
	{109, 0x00},
	{110, 0x00},
	{111, 0x00},
	{112, 0x00},
	{113, 0x00},
	{114, 0x00},
	{115, 0x00},
	{116, 0x00},
	{117, 0x00},
	{118, 0x00},
	{119, 0x00},
	{120, 0x00},
	{121, 0x00},
	{122, 0x00},
	{123, 0x00},
	{124, 0x00},
	{125, 0x00},
	{126, 0x00},
	{127, 0x00},
	{  0, 0x0D},
	{  8, 0x00},
	{  9, 0x00},
	{ 10, 0x00},
	{ 11, 0x00},
	{ 12, 0x00},
	{ 13, 0x00},
	{ 14, 0x00},
	{ 15, 0x00},
	{ 16, 0x00},
	{ 17, 0x00},
	{ 18, 0x00},
	{ 19, 0x00},
	{ 20, 0x00},
	{ 21, 0x00},
	{ 22, 0x00},
	{ 23, 0x00},
	{ 24, 0x00},
	{ 25, 0x00},
	{ 26, 0x00},
	{ 27, 0x00},
	{ 28, 0x00},
	{ 29, 0x00},
	{ 30, 0x00},
	{ 31, 0x00},
	{ 32, 0x00},
	{ 33, 0x00},
	{ 34, 0x00},
	{ 35, 0x00},
	{ 36, 0x00},
	{ 37, 0x00},
	{ 38, 0x00},
	{ 39, 0x00},
	{ 40, 0x00},
	{ 41, 0x00},
	{ 42, 0x00},
	{ 43, 0x00},
	{ 44, 0x00},
	{ 45, 0x00},
	{ 46, 0x00},
	{ 47, 0x00},
	{ 48, 0x00},
	{ 49, 0x00},
	{ 50, 0x00},
	{ 51, 0x00},
	{ 52, 0x00},
	{ 53, 0x00},
	{ 54, 0x00},
	{ 55, 0x00},
	{ 56, 0x00},
	{ 57, 0x00},
	{ 58, 0x00},
	{ 59, 0x00},
	{  0, 0x0},
	{  0x7F, 0x14},
	{  0, 0x01},
	{  8, 0xC0},
	{  9, 0x00},
	{ 10, 0x00},
	{ 11, 0x00},
	{ 12, 0xC0},
	{ 13, 0x00},
	{ 14, 0x00},
	{ 15, 0x00},
	{  0, 0x0},
	{  0x7F, 0x64},
	{  0, 0x01},
	{  8, 0x58},
	{  9, 0x60},
	{ 10, 0x08},
	{ 11, 0x01},
	{ 12, 0x60},
	{ 13, 0x60},
	{ 14, 0x00},
	{ 15, 0x00},
	{ 16, 0x58},
	{ 17, 0x60},
	{ 18, 0x00},
	{ 19, 0x2B},
	{ 20, 0x00},
	{ 21, 0x00},
	{ 22, 0x00},
	{ 23, 0x00},
	{ 24, 0x44},
	{ 25, 0x00},
	{ 26, 0xC0},
	{ 27, 0x07},
	{ 28, 0x04},
	{ 29, 0x00},
	{ 30, 0x00},
	{ 31, 0x00},
	{ 32, 0x04},
	{ 33, 0x00},
	{ 34, 0x00},
	{ 35, 0x0D},
	{ 36, 0x04},
	{ 37, 0x00},
	{ 38, 0x00},
	{ 39, 0x08},
	{ 40, 0x04},
	{ 41, 0x00},
	{ 42, 0x00},
	{ 43, 0x04},
	{ 44, 0x00},
	{ 45, 0x00},
	{ 46, 0x00},
	{ 47, 0x00},
	{ 48, 0x00},
	{ 49, 0x00},
	{ 50, 0x00},
	{ 51, 0x00},
	{ 52, 0x44},
	{ 53, 0x00},
	{ 54, 0x00},
	{ 55, 0x07},
	{ 56, 0x21},
	{ 57, 0x00},
	{ 58, 0x20},
	{ 59, 0x00},
	{ 60, 0x4B},
	{ 61, 0x00},
	{ 62, 0xC0},
	{ 63, 0x00},
	{ 64, 0x4B},
	{ 65, 0x00},
	{ 66, 0xE0},
	{ 67, 0x00},
	{ 68, 0x10},
	{ 69, 0x00},
	{ 70, 0x00},
	{ 71, 0x00},
	{ 72, 0x10},
	{ 73, 0x00},
	{ 74, 0x00},
	{ 75, 0x0D},
	{ 76, 0x10},
	{ 77, 0x00},
	{ 78, 0x00},
	{ 79, 0x08},
	{ 80, 0x10},
	{ 81, 0x00},
	{ 82, 0x00},
	{ 83, 0x04},
	{ 84, 0x18},
	{ 85, 0x06},
	{ 86, 0x00},
	{ 87, 0x0F},
	{ 88, 0x1C},
	{ 89, 0x05},
	{ 90, 0xE0},
	{ 91, 0x09},
	{ 92, 0x1C},
	{ 93, 0x05},
	{ 94, 0xE0},
	{ 95, 0x03},
	{ 96, 0x1C},
	{ 97, 0x05},
	{ 98, 0xC0},
	{ 99, 0x0A},
	{100, 0x1C},
	{101, 0x05},
	{102, 0xC0},
	{103, 0x02},
	{104, 0x1C},
	{105, 0x05},
	{106, 0x80},
	{107, 0x0C},
	{108, 0x1C},
	{109, 0x05},
	{110, 0x80},
	{111, 0x00},
	{112, 0x1C},
	{113, 0x05},
	{114, 0xA0},
	{115, 0x01},
	{116, 0x1C},
	{117, 0x05},
	{118, 0xA0},
	{119, 0x0B},
	{120, 0x18},
	{121, 0x05},
	{122, 0x80},
	{123, 0x03},
	{124, 0x1C},
	{125, 0x05},
	{126, 0x80},
	{127, 0x08},
	{  0, 0x02},
	{  8, 0x1C},
	{  9, 0x05},
	{ 10, 0xA0},
	{ 11, 0x09},
	{ 12, 0x10},
	{ 13, 0x00},
	{ 14, 0x00},
	{ 15, 0x2D},
	{ 16, 0x1C},
	{ 17, 0x05},
	{ 18, 0xA0},
	{ 19, 0x02},
	{ 20, 0x1C},
	{ 21, 0x05},
	{ 22, 0xC0},
	{ 23, 0x01},
	{ 24, 0x1C},
	{ 25, 0x05},
	{ 26, 0xC0},
	{ 27, 0x0A},
	{ 28, 0x1C},
	{ 29, 0x05},
	{ 30, 0xE0},
	{ 31, 0x00},
	{ 32, 0x1C},
	{ 33, 0x05},
	{ 34, 0xE0},
	{ 35, 0x0B},
	{ 36, 0x1C},
	{ 37, 0x06},
	{ 38, 0x00},
	{ 39, 0x06},
	{ 40, 0x00},
	{ 41, 0x00},
	{ 42, 0x00},
	{ 43, 0x00},
	{ 44, 0x00},
	{ 45, 0x00},
	{ 46, 0x00},
	{ 47, 0x00},
	{ 48, 0x00},
	{ 49, 0x00},
	{ 50, 0x00},
	{ 51, 0x00},
	{ 52, 0x10},
	{ 53, 0x00},
	{ 54, 0x00},
	{ 55, 0x0F},
	{ 56, 0x18},
	{ 57, 0x06},
	{ 58, 0x20},
	{ 59, 0x2C},
	{ 60, 0x1C},
	{ 61, 0x06},
	{ 62, 0x40},
	{ 63, 0x11},
	{ 64, 0x1C},
	{ 65, 0x06},
	{ 66, 0x40},
	{ 67, 0x48},
	{ 68, 0x1C},
	{ 69, 0x06},
	{ 70, 0x20},
	{ 71, 0x2D},
	{ 72, 0x1C},
	{ 73, 0x06},
	{ 74, 0x60},
	{ 75, 0x2F},
	{ 76, 0x1C},
	{ 77, 0x06},
	{ 78, 0x60},
	{ 79, 0x2A},
	{ 80, 0x1C},
	{ 81, 0x06},
	{ 82, 0x80},
	{ 83, 0x31},
	{ 84, 0x1C},
	{ 85, 0x06},
	{ 86, 0x80},
	{ 87, 0x28},
	{ 88, 0x1C},
	{ 89, 0x06},
	{ 90, 0xA0},
	{ 91, 0x37},
	{ 92, 0x1C},
	{ 93, 0x06},
	{ 94, 0xA0},
	{ 95, 0x22},
	{ 96, 0x1C},
	{ 97, 0x06},
	{ 98, 0xC0},
	{ 99, 0x14},
	{100, 0x1C},
	{101, 0x06},
	{102, 0xC0},
	{103, 0x45},
	{104, 0x1C},
	{105, 0x06},
	{106, 0xE0},
	{107, 0x12},
	{108, 0x1C},
	{109, 0x06},
	{110, 0xE0},
	{111, 0x47},
	{112, 0x1C},
	{113, 0x07},
	{114, 0x00},
	{115, 0x38},
	{116, 0x1C},
	{117, 0x07},
	{118, 0x00},
	{119, 0x21},
	{120, 0x1C},
	{121, 0x07},
	{122, 0x20},
	{123, 0x33},
	{124, 0x1C},
	{125, 0x07},
	{126, 0x20},
	{127, 0x26},
	{  0, 0x03},
	{  8, 0x1C},
	{  9, 0x07},
	{ 10, 0x40},
	{ 11, 0x16},
	{ 12, 0x1C},
	{ 13, 0x07},
	{ 14, 0x40},
	{ 15, 0x43},
	{ 16, 0x1C},
	{ 17, 0x07},
	{ 18, 0x60},
	{ 19, 0x35},
	{ 20, 0x1C},
	{ 21, 0x07},
	{ 22, 0x60},
	{ 23, 0x24},
	{ 24, 0x1C},
	{ 25, 0x07},
	{ 26, 0x80},
	{ 27, 0x1A},
	{ 28, 0x1C},
	{ 29, 0x07},
	{ 30, 0x80},
	{ 31, 0x3F},
	{ 32, 0x1C},
	{ 33, 0x07},
	{ 34, 0xA0},
	{ 35, 0x3A},
	{ 36, 0x1C},
	{ 37, 0x07},
	{ 38, 0xA0},
	{ 39, 0x1F},
	{ 40, 0x1C},
	{ 41, 0x07},
	{ 42, 0xC0},
	{ 43, 0x18},
	{ 44, 0x1C},
	{ 45, 0x07},
	{ 46, 0xC0},
	{ 47, 0x41},
	{ 48, 0x1C},
	{ 49, 0x07},
	{ 50, 0xE0},
	{ 51, 0x1C},
	{ 52, 0x1C},
	{ 53, 0x07},
	{ 54, 0xE0},
	{ 55, 0x3D},
	{ 56, 0x1C},
	{ 57, 0x08},
	{ 58, 0x00},
	{ 59, 0x19},
	{ 60, 0x1C},
	{ 61, 0x08},
	{ 62, 0x00},
	{ 63, 0x40},
	{ 64, 0x1C},
	{ 65, 0x08},
	{ 66, 0x20},
	{ 67, 0x30},
	{ 68, 0x1C},
	{ 69, 0x08},
	{ 70, 0x20},
	{ 71, 0x29},
	{ 72, 0x1C},
	{ 73, 0x08},
	{ 74, 0x40},
	{ 75, 0x15},
	{ 76, 0x1C},
	{ 77, 0x08},
	{ 78, 0x40},
	{ 79, 0x44},
	{ 80, 0x1C},
	{ 81, 0x08},
	{ 82, 0x60},
	{ 83, 0x3B},
	{ 84, 0x1C},
	{ 85, 0x08},
	{ 86, 0x60},
	{ 87, 0x1E},
	{ 88, 0x1C},
	{ 89, 0x08},
	{ 90, 0x80},
	{ 91, 0x34},
	{ 92, 0x1C},
	{ 93, 0x08},
	{ 94, 0x80},
	{ 95, 0x25},
	{ 96, 0x1C},
	{ 97, 0x08},
	{ 98, 0xA0},
	{ 99, 0x36},
	{100, 0x1C},
	{101, 0x08},
	{102, 0xA0},
	{103, 0x23},
	{104, 0x1C},
	{105, 0x08},
	{106, 0xC0},
	{107, 0x32},
	{108, 0x1C},
	{109, 0x08},
	{110, 0xC0},
	{111, 0x27},
	{112, 0x1C},
	{113, 0x08},
	{114, 0xE0},
	{115, 0x13},
	{116, 0x1C},
	{117, 0x08},
	{118, 0xE0},
	{119, 0x46},
	{120, 0x1C},
	{121, 0x09},
	{122, 0x00},
	{123, 0x2E},
	{124, 0x1C},
	{125, 0x09},
	{126, 0x00},
	{127, 0x2B},
	{  0, 0x04},
	{  8, 0x1C},
	{  9, 0x09},
	{ 10, 0x20},
	{ 11, 0x10},
	{ 12, 0x1C},
	{ 13, 0x09},
	{ 14, 0x20},
	{ 15, 0x49},
	{ 16, 0x1C},
	{ 17, 0x09},
	{ 18, 0x40},
	{ 19, 0x17},
	{ 20, 0x1C},
	{ 21, 0x09},
	{ 22, 0x40},
	{ 23, 0x42},
	{ 24, 0x1C},
	{ 25, 0x09},
	{ 26, 0x60},
	{ 27, 0x1D},
	{ 28, 0x1C},
	{ 29, 0x09},
	{ 30, 0x60},
	{ 31, 0x3C},
	{ 32, 0x1C},
	{ 33, 0x09},
	{ 34, 0x80},
	{ 35, 0x1B},
	{ 36, 0x1C},
	{ 37, 0x09},
	{ 38, 0x80},
	{ 39, 0x3E},
	{ 40, 0x1C},
	{ 41, 0x09},
	{ 42, 0xA0},
	{ 43, 0x39},
	{ 44, 0x1C},
	{ 45, 0x09},
	{ 46, 0xA0},
	{ 47, 0x20},
	{ 48, 0x00},
	{ 49, 0x00},
	{ 50, 0x00},
	{ 51, 0x00},
	{ 52, 0x5C},
	{ 53, 0x90},
	{ 54, 0x40},
	{ 55, 0x00},
	{ 56, 0x00},
	{ 57, 0x00},
	{ 58, 0x00},
	{ 59, 0x00},
	{ 60, 0x5C},
	{ 61, 0x90},
	{ 62, 0x20},
	{ 63, 0x00},
	{ 64, 0x00},
	{ 65, 0x00},
	{ 66, 0x00},
	{ 67, 0x00},
	{ 68, 0x00},
	{ 69, 0x00},
	{ 70, 0x00},
	{ 71, 0x00},
	{ 72, 0x00},
	{ 73, 0x00},
	{ 74, 0x00},
	{ 75, 0x00},
	{ 76, 0x10},
	{ 77, 0x00},
	{ 78, 0x00},
	{ 79, 0x49},
	{ 80, 0x18},
	{ 81, 0x00},
	{ 82, 0x60},
	{ 83, 0x4A},
	{ 84, 0x1C},
	{ 85, 0x00},
	{ 86, 0x80},
	{ 87, 0x4C},
	{ 88, 0x1C},
	{ 89, 0x00},
	{ 90, 0x40},
	{ 91, 0x49},
	{ 92, 0x30},
	{ 93, 0x00},
	{ 94, 0x00},
	{ 95, 0x4C},
	{ 96, 0x1C},
	{ 97, 0x00},
	{ 98, 0x20},
	{ 99, 0x4E},
	{100, 0x00},
	{101, 0x00},
	{102, 0x00},
	{103, 0x00},
	{104, 0x10},
	{105, 0x30},
	{106, 0x00},
	{107, 0x4B},
	{108, 0x34},
	{109, 0x00},
	{110, 0x00},
	{111, 0x4B},
	{112, 0x5C},
	{113, 0x60},
	{114, 0xA0},
	{115, 0x4B},
	{116, 0x0C},
	{117, 0x00},
	{118, 0x40},
	{119, 0x00},
	{120, 0x00},
	{121, 0x00},
	{122, 0x00},
	{123, 0x00},
	{124, 0x10},
	{125, 0x30},
	{126, 0x00},
	{127, 0x4D},
	{  0, 0x05},
	{  8, 0x10},
	{  9, 0x13},
	{ 10, 0xE0},
	{ 11, 0x50},
	{ 12, 0x18},
	{ 13, 0x05},
	{ 14, 0x20},
	{ 15, 0x50},
	{ 16, 0x00},
	{ 17, 0x00},
	{ 18, 0x00},
	{ 19, 0x00},
	{ 20, 0x00},
	{ 21, 0x00},
	{ 22, 0x00},
	{ 23, 0x00},
	{ 24, 0x18},
	{ 25, 0x05},
	{ 26, 0x00},
	{ 27, 0x58},
	{ 28, 0x4C},
	{ 29, 0x05},
	{ 30, 0x20},
	{ 31, 0x56},
	{ 32, 0x00},
	{ 33, 0x00},
	{ 34, 0x00},
	{ 35, 0x00},
	{ 36, 0x00},
	{ 37, 0x00},
	{ 38, 0x00},
	{ 39, 0x00},
	{ 40, 0x00},
	{ 41, 0x00},
	{ 42, 0x00},
	{ 43, 0x00},
	{ 44, 0x10},
	{ 45, 0x13},
	{ 46, 0xC0},
	{ 47, 0x59},
	{ 48, 0x18},
	{ 49, 0x00},
	{ 50, 0xE0},
	{ 51, 0x59},
	{ 52, 0x6C},
	{ 53, 0x01},
	{ 54, 0x20},
	{ 55, 0x5B},
	{ 56, 0x1C},
	{ 57, 0x01},
	{ 58, 0x40},
	{ 59, 0x5C},
	{ 60, 0x18},
	{ 61, 0x01},
	{ 62, 0x60},
	{ 63, 0x59},
	{ 64, 0x6C},
	{ 65, 0x01},
	{ 66, 0xA0},
	{ 67, 0x61},
	{ 68, 0x1C},
	{ 69, 0x01},
	{ 70, 0xC0},
	{ 71, 0x62},
	{ 72, 0x10},
	{ 73, 0x00},
	{ 74, 0x00},
	{ 75, 0x5A},
	{ 76, 0x18},
	{ 77, 0x01},
	{ 78, 0xE0},
	{ 79, 0x59},
	{ 80, 0x6C},
	{ 81, 0x02},
	{ 82, 0x20},
	{ 83, 0x67},
	{ 84, 0x1C},
	{ 85, 0x02},
	{ 86, 0x40},
	{ 87, 0x68},
	{ 88, 0x10},
	{ 89, 0x00},
	{ 90, 0x00},
	{ 91, 0x60},
	{ 92, 0x18},
	{ 93, 0x02},
	{ 94, 0x60},
	{ 95, 0x59},
	{ 96, 0x6C},
	{ 97, 0x02},
	{ 98, 0xA0},
	{ 99, 0x6D},
	{100, 0x1C},
	{101, 0x02},
	{102, 0xC0},
	{103, 0x6E},
	{104, 0x10},
	{105, 0x00},
	{106, 0x00},
	{107, 0x66},
	{108, 0x18},
	{109, 0x02},
	{110, 0xE0},
	{111, 0x59},
	{112, 0x6C},
	{113, 0x03},
	{114, 0x20},
	{115, 0x73},
	{116, 0x1C},
	{117, 0x03},
	{118, 0x40},
	{119, 0x74},
	{120, 0x10},
	{121, 0x00},
	{122, 0x00},
	{123, 0x6C},
	{124, 0x18},
	{125, 0x03},
	{126, 0x60},
	{127, 0x59},
	{  0, 0x06},
	{  8, 0x6C},
	{  9, 0x03},
	{ 10, 0xA0},
	{ 11, 0x79},
	{ 12, 0x1C},
	{ 13, 0x03},
	{ 14, 0xC0},
	{ 15, 0x7A},
	{ 16, 0x10},
	{ 17, 0x00},
	{ 18, 0x00},
	{ 19, 0x72},
	{ 20, 0x18},
	{ 21, 0x03},
	{ 22, 0xE0},
	{ 23, 0x59},
	{ 24, 0x6C},
	{ 25, 0x04},
	{ 26, 0x20},
	{ 27, 0x7F},
	{ 28, 0x1C},
	{ 29, 0x04},
	{ 30, 0x40},
	{ 31, 0x80},
	{ 32, 0x10},
	{ 33, 0x00},
	{ 34, 0x00},
	{ 35, 0x78},
	{ 36, 0x18},
	{ 37, 0x04},
	{ 38, 0x60},
	{ 39, 0x59},
	{ 40, 0x6C},
	{ 41, 0x04},
	{ 42, 0xA0},
	{ 43, 0x85},
	{ 44, 0x1C},
	{ 45, 0x04},
	{ 46, 0xC0},
	{ 47, 0x86},
	{ 48, 0x10},
	{ 49, 0x00},
	{ 50, 0x00},
	{ 51, 0x7E},
	{ 52, 0x00},
	{ 53, 0x00},
	{ 54, 0x00},
	{ 55, 0x00},
	{ 56, 0x00},
	{ 57, 0x00},
	{ 58, 0x00},
	{ 59, 0x00},
	{ 60, 0x10},
	{ 61, 0x00},
	{ 62, 0x00},
	{ 63, 0x84},
	{ 64, 0x18},
	{ 65, 0x01},
	{ 66, 0x00},
	{ 67, 0x5A},
	{ 68, 0x1C},
	{ 69, 0x00},
	{ 70, 0xE0},
	{ 71, 0x5C},
	{ 72, 0x6C},
	{ 73, 0x01},
	{ 74, 0x20},
	{ 75, 0x5E},
	{ 76, 0x1C},
	{ 77, 0x01},
	{ 78, 0x40},
	{ 79, 0x5F},
	{ 80, 0x18},
	{ 81, 0x01},
	{ 82, 0x60},
	{ 83, 0x60},
	{ 84, 0x1C},
	{ 85, 0x01},
	{ 86, 0x80},
	{ 87, 0x62},
	{ 88, 0x6C},
	{ 89, 0x01},
	{ 90, 0xA0},
	{ 91, 0x64},
	{ 92, 0x10},
	{ 93, 0x00},
	{ 94, 0x00},
	{ 95, 0x5D},
	{ 96, 0x1C},
	{ 97, 0x01},
	{ 98, 0xC0},
	{ 99, 0x65},
	{100, 0x18},
	{101, 0x02},
	{102, 0x00},
	{103, 0x66},
	{104, 0x1C},
	{105, 0x01},
	{106, 0xE0},
	{107, 0x68},
	{108, 0x6C},
	{109, 0x02},
	{110, 0x20},
	{111, 0x6A},
	{112, 0x10},
	{113, 0x00},
	{114, 0x00},
	{115, 0x63},
	{116, 0x1C},
	{117, 0x02},
	{118, 0x40},
	{119, 0x6B},
	{120, 0x18},
	{121, 0x02},
	{122, 0x60},
	{123, 0x6C},
	{124, 0x1C},
	{125, 0x02},
	{126, 0x80},
	{127, 0x6E},
	{  0, 0x07},
	{  8, 0x6C},
	{  9, 0x02},
	{ 10, 0xA0},
	{ 11, 0x70},
	{ 12, 0x10},
	{ 13, 0x00},
	{ 14, 0x00},
	{ 15, 0x69},
	{ 16, 0x1C},
	{ 17, 0x02},
	{ 18, 0xC0},
	{ 19, 0x71},
	{ 20, 0x18},
	{ 21, 0x03},
	{ 22, 0x00},
	{ 23, 0x72},
	{ 24, 0x1C},
	{ 25, 0x02},
	{ 26, 0xE0},
	{ 27, 0x74},
	{ 28, 0x6C},
	{ 29, 0x03},
	{ 30, 0x20},
	{ 31, 0x76},
	{ 32, 0x10},
	{ 33, 0x00},
	{ 34, 0x00},
	{ 35, 0x6F},
	{ 36, 0x1C},
	{ 37, 0x03},
	{ 38, 0x40},
	{ 39, 0x77},
	{ 40, 0x18},
	{ 41, 0x03},
	{ 42, 0x60},
	{ 43, 0x78},
	{ 44, 0x1C},
	{ 45, 0x03},
	{ 46, 0x80},
	{ 47, 0x7A},
	{ 48, 0x6C},
	{ 49, 0x03},
	{ 50, 0xA0},
	{ 51, 0x7C},
	{ 52, 0x10},
	{ 53, 0x00},
	{ 54, 0x00},
	{ 55, 0x75},
	{ 56, 0x1C},
	{ 57, 0x03},
	{ 58, 0xC0},
	{ 59, 0x7D},
	{ 60, 0x18},
	{ 61, 0x04},
	{ 62, 0x00},
	{ 63, 0x7E},
	{ 64, 0x1C},
	{ 65, 0x03},
	{ 66, 0xE0},
	{ 67, 0x80},
	{ 68, 0x6C},
	{ 69, 0x04},
	{ 70, 0x20},
	{ 71, 0x82},
	{ 72, 0x10},
	{ 73, 0x00},
	{ 74, 0x00},
	{ 75, 0x7B},
	{ 76, 0x1C},
	{ 77, 0x04},
	{ 78, 0x40},
	{ 79, 0x83},
	{ 80, 0x18},
	{ 81, 0x04},
	{ 82, 0x60},
	{ 83, 0x84},
	{ 84, 0x1C},
	{ 85, 0x04},
	{ 86, 0x80},
	{ 87, 0x86},
	{ 88, 0x6C},
	{ 89, 0x04},
	{ 90, 0xA0},
	{ 91, 0x88},
	{ 92, 0x10},
	{ 93, 0x00},
	{ 94, 0x00},
	{ 95, 0x81},
	{ 96, 0x1C},
	{ 97, 0x04},
	{ 98, 0xC0},
	{ 99, 0x89},
	{100, 0x00},
	{101, 0x00},
	{102, 0x00},
	{103, 0x00},
	{104, 0x00},
	{105, 0x00},
	{106, 0x00},
	{107, 0x00},
	{108, 0x00},
	{109, 0x00},
	{110, 0x00},
	{111, 0x00},
	{112, 0x10},
	{113, 0x00},
	{114, 0x00},
	{115, 0x87},
	{116, 0x18},
	{117, 0x0A},
	{118, 0x20},
	{119, 0x94},
	{120, 0x34},
	{121, 0x09},
	{122, 0xE0},
	{123, 0x5D},
	{124, 0x18},
	{125, 0x0A},
	{126, 0x20},
	{127, 0x94},
	{  0, 0x08},
	{  8, 0x00},
	{  9, 0x00},
	{ 10, 0x00},
	{ 11, 0x00},
	{ 12, 0x30},
	{ 13, 0x05},
	{ 14, 0x20},
	{ 15, 0x5D},
	{ 16, 0x44},
	{ 17, 0x00},
	{ 18, 0xC0},
	{ 19, 0x04},
	{ 20, 0x10},
	{ 21, 0x00},
	{ 22, 0x00},
	{ 23, 0x93},
	{ 24, 0x20},
	{ 25, 0x0B},
	{ 26, 0xA0},
	{ 27, 0x02},
	{ 28, 0x00},
	{ 29, 0x00},
	{ 30, 0x00},
	{ 31, 0x00},
	{ 32, 0x44},
	{ 33, 0x00},
	{ 34, 0x00},
	{ 35, 0x04},
	{ 36, 0x00},
	{ 37, 0x00},
	{ 38, 0x00},
	{ 39, 0x00},
	{ 40, 0x00},
	{ 41, 0x00},
	{ 42, 0x00},
	{ 43, 0x00},
	{ 44, 0x10},
	{ 45, 0x00},
	{ 46, 0x00},
	{ 47, 0x93},
	{ 48, 0x20},
	{ 49, 0x0B},
	{ 50, 0xA0},
	{ 51, 0x02},
	{ 52, 0x18},
	{ 53, 0x0A},
	{ 54, 0x20},
	{ 55, 0x96},
	{ 56, 0x34},
	{ 57, 0x09},
	{ 58, 0xE0},
	{ 59, 0x63},
	{ 60, 0x18},
	{ 61, 0x0A},
	{ 62, 0x20},
	{ 63, 0x96},
	{ 64, 0x00},
	{ 65, 0x00},
	{ 66, 0x00},
	{ 67, 0x00},
	{ 68, 0x30},
	{ 69, 0x05},
	{ 70, 0x20},
	{ 71, 0x63},
	{ 72, 0x44},
	{ 73, 0x00},
	{ 74, 0xC0},
	{ 75, 0x04},
	{ 76, 0x10},
	{ 77, 0x00},
	{ 78, 0x00},
	{ 79, 0x95},
	{ 80, 0x20},
	{ 81, 0x0C},
	{ 82, 0x00},
	{ 83, 0x02},
	{ 84, 0x00},
	{ 85, 0x00},
	{ 86, 0x00},
	{ 87, 0x00},
	{ 88, 0x44},
	{ 89, 0x00},
	{ 90, 0x00},
	{ 91, 0x04},
	{ 92, 0x00},
	{ 93, 0x00},
	{ 94, 0x00},
	{ 95, 0x00},
	{ 96, 0x00},
	{ 97, 0x00},
	{ 98, 0x00},
	{ 99, 0x00},
	{100, 0x10},
	{101, 0x00},
	{102, 0x00},
	{103, 0x95},
	{104, 0x20},
	{105, 0x0C},
	{106, 0x00},
	{107, 0x02},
	{108, 0x18},
	{109, 0x0A},
	{110, 0x20},
	{111, 0x98},
	{112, 0x34},
	{113, 0x09},
	{114, 0xE0},
	{115, 0x69},
	{116, 0x18},
	{117, 0x0A},
	{118, 0x20},
	{119, 0x98},
	{120, 0x00},
	{121, 0x00},
	{122, 0x00},
	{123, 0x00},
	{124, 0x30},
	{125, 0x05},
	{126, 0x20},
	{127, 0x69},
	{  0, 0x09},
	{  8, 0x44},
	{  9, 0x00},
	{ 10, 0xC0},
	{ 11, 0x04},
	{ 12, 0x10},
	{ 13, 0x00},
	{ 14, 0x00},
	{ 15, 0x97},
	{ 16, 0x20},
	{ 17, 0x0C},
	{ 18, 0x60},
	{ 19, 0x02},
	{ 20, 0x00},
	{ 21, 0x00},
	{ 22, 0x00},
	{ 23, 0x00},
	{ 24, 0x44},
	{ 25, 0x00},
	{ 26, 0x00},
	{ 27, 0x04},
	{ 28, 0x00},
	{ 29, 0x00},
	{ 30, 0x00},
	{ 31, 0x00},
	{ 32, 0x00},
	{ 33, 0x00},
	{ 34, 0x00},
	{ 35, 0x00},
	{ 36, 0x10},
	{ 37, 0x00},
	{ 38, 0x00},
	{ 39, 0x97},
	{ 40, 0x20},
	{ 41, 0x0C},
	{ 42, 0x60},
	{ 43, 0x02},
	{ 44, 0x18},
	{ 45, 0x0A},
	{ 46, 0x20},
	{ 47, 0x9A},
	{ 48, 0x34},
	{ 49, 0x09},
	{ 50, 0xE0},
	{ 51, 0x6F},
	{ 52, 0x18},
	{ 53, 0x0A},
	{ 54, 0x20},
	{ 55, 0x9A},
	{ 56, 0x00},
	{ 57, 0x00},
	{ 58, 0x00},
	{ 59, 0x00},
	{ 60, 0x30},
	{ 61, 0x05},
	{ 62, 0x20},
	{ 63, 0x6F},
	{ 64, 0x44},
	{ 65, 0x00},
	{ 66, 0xC0},
	{ 67, 0x04},
	{ 68, 0x10},
	{ 69, 0x00},
	{ 70, 0x00},
	{ 71, 0x99},
	{ 72, 0x20},
	{ 73, 0x0C},
	{ 74, 0xC0},
	{ 75, 0x02},
	{ 76, 0x00},
	{ 77, 0x00},
	{ 78, 0x00},
	{ 79, 0x00},
	{ 80, 0x44},
	{ 81, 0x00},
	{ 82, 0x00},
	{ 83, 0x04},
	{ 84, 0x00},
	{ 85, 0x00},
	{ 86, 0x00},
	{ 87, 0x00},
	{ 88, 0x00},
	{ 89, 0x00},
	{ 90, 0x00},
	{ 91, 0x00},
	{ 92, 0x10},
	{ 93, 0x00},
	{ 94, 0x00},
	{ 95, 0x99},
	{ 96, 0x20},
	{ 97, 0x0C},
	{ 98, 0xC0},
	{ 99, 0x02},
	{100, 0x18},
	{101, 0x0A},
	{102, 0x20},
	{103, 0x9C},
	{104, 0x34},
	{105, 0x09},
	{106, 0xE0},
	{107, 0x75},
	{108, 0x18},
	{109, 0x0A},
	{110, 0x20},
	{111, 0x9C},
	{112, 0x00},
	{113, 0x00},
	{114, 0x00},
	{115, 0x00},
	{116, 0x30},
	{117, 0x05},
	{118, 0x20},
	{119, 0x75},
	{120, 0x44},
	{121, 0x00},
	{122, 0xC0},
	{123, 0x04},
	{124, 0x10},
	{125, 0x00},
	{126, 0x00},
	{127, 0x9B},
	{  0, 0x0A},
	{  8, 0x20},
	{  9, 0x0D},
	{ 10, 0x20},
	{ 11, 0x02},
	{ 12, 0x00},
	{ 13, 0x00},
	{ 14, 0x00},
	{ 15, 0x00},
	{ 16, 0x44},
	{ 17, 0x00},
	{ 18, 0x00},
	{ 19, 0x04},
	{ 20, 0x00},
	{ 21, 0x00},
	{ 22, 0x00},
	{ 23, 0x00},
	{ 24, 0x00},
	{ 25, 0x00},
	{ 26, 0x00},
	{ 27, 0x00},
	{ 28, 0x10},
	{ 29, 0x00},
	{ 30, 0x00},
	{ 31, 0x9B},
	{ 32, 0x20},
	{ 33, 0x0D},
	{ 34, 0x20},
	{ 35, 0x02},
	{ 36, 0x18},
	{ 37, 0x0A},
	{ 38, 0x20},
	{ 39, 0x9E},
	{ 40, 0x34},
	{ 41, 0x09},
	{ 42, 0xE0},
	{ 43, 0x7B},
	{ 44, 0x18},
	{ 45, 0x0A},
	{ 46, 0x20},
	{ 47, 0x9E},
	{ 48, 0x00},
	{ 49, 0x00},
	{ 50, 0x00},
	{ 51, 0x00},
	{ 52, 0x30},
	{ 53, 0x05},
	{ 54, 0x20},
	{ 55, 0x7B},
	{ 56, 0x44},
	{ 57, 0x00},
	{ 58, 0xC0},
	{ 59, 0x04},
	{ 60, 0x10},
	{ 61, 0x00},
	{ 62, 0x00},
	{ 63, 0x9D},
	{ 64, 0x20},
	{ 65, 0x0D},
	{ 66, 0x80},
	{ 67, 0x02},
	{ 68, 0x00},
	{ 69, 0x00},
	{ 70, 0x00},
	{ 71, 0x00},
	{ 72, 0x44},
	{ 73, 0x00},
	{ 74, 0x00},
	{ 75, 0x04},
	{ 76, 0x00},
	{ 77, 0x00},
	{ 78, 0x00},
	{ 79, 0x00},
	{ 80, 0x00},
	{ 81, 0x00},
	{ 82, 0x00},
	{ 83, 0x00},
	{ 84, 0x10},
	{ 85, 0x00},
	{ 86, 0x00},
	{ 87, 0x9D},
	{ 88, 0x20},
	{ 89, 0x0D},
	{ 90, 0x80},
	{ 91, 0x02},
	{ 92, 0x18},
	{ 93, 0x0A},
	{ 94, 0x20},
	{ 95, 0xA0},
	{ 96, 0x34},
	{ 97, 0x09},
	{ 98, 0xE0},
	{ 99, 0x81},
	{100, 0x18},
	{101, 0x0A},
	{102, 0x20},
	{103, 0xA0},
	{104, 0x00},
	{105, 0x00},
	{106, 0x00},
	{107, 0x00},
	{108, 0x30},
	{109, 0x05},
	{110, 0x20},
	{111, 0x81},
	{112, 0x44},
	{113, 0x00},
	{114, 0xC0},
	{115, 0x04},
	{116, 0x10},
	{117, 0x00},
	{118, 0x00},
	{119, 0x9F},
	{120, 0x20},
	{121, 0x0D},
	{122, 0xE0},
	{123, 0x02},
	{124, 0x00},
	{125, 0x00},
	{126, 0x00},
	{127, 0x00},
	{  0, 0x0B},
	{  8, 0x44},
	{  9, 0x00},
	{ 10, 0x00},
	{ 11, 0x04},
	{ 12, 0x00},
	{ 13, 0x00},
	{ 14, 0x00},
	{ 15, 0x00},
	{ 16, 0x00},
	{ 17, 0x00},
	{ 18, 0x00},
	{ 19, 0x00},
	{ 20, 0x10},
	{ 21, 0x00},
	{ 22, 0x00},
	{ 23, 0x9F},
	{ 24, 0x20},
	{ 25, 0x0D},
	{ 26, 0xE0},
	{ 27, 0x02},
	{ 28, 0x18},
	{ 29, 0x0A},
	{ 30, 0x20},
	{ 31, 0xA2},
	{ 32, 0x34},
	{ 33, 0x09},
	{ 34, 0xE0},
	{ 35, 0x87},
	{ 36, 0x18},
	{ 37, 0x0A},
	{ 38, 0x20},
	{ 39, 0xA2},
	{ 40, 0x00},
	{ 41, 0x00},
	{ 42, 0x00},
	{ 43, 0x00},
	{ 44, 0x30},
	{ 45, 0x05},
	{ 46, 0x20},
	{ 47, 0x87},
	{ 48, 0x44},
	{ 49, 0x00},
	{ 50, 0xC0},
	{ 51, 0x04},
	{ 52, 0x10},
	{ 53, 0x00},
	{ 54, 0x00},
	{ 55, 0xA1},
	{ 56, 0x20},
	{ 57, 0x0E},
	{ 58, 0x40},
	{ 59, 0x02},
	{ 60, 0x00},
	{ 61, 0x00},
	{ 62, 0x00},
	{ 63, 0x00},
	{ 64, 0x44},
	{ 65, 0x00},
	{ 66, 0x00},
	{ 67, 0x04},
	{ 68, 0x00},
	{ 69, 0x00},
	{ 70, 0x00},
	{ 71, 0x00},
	{ 72, 0x00},
	{ 73, 0x00},
	{ 74, 0x00},
	{ 75, 0x00},
	{ 76, 0x10},
	{ 77, 0x00},
	{ 78, 0x00},
	{ 79, 0xA1},
	{ 80, 0x20},
	{ 81, 0x0E},
	{ 82, 0x40},
	{ 83, 0x02},
	{ 84, 0x58},
	{ 85, 0x60},
	{ 86, 0x00},
	{ 87, 0x2A},
	{ 88, 0x1C},
	{ 89, 0x09},
	{ 90, 0xC0},
	{ 91, 0xBB},
	{ 92, 0x1C},
	{ 93, 0x09},
	{ 94, 0xC0},
	{ 95, 0xBC},
	{ 96, 0x1C},
	{ 97, 0x09},
	{ 98, 0xC0},
	{ 99, 0xBD},
	{100, 0x1C},
	{101, 0x09},
	{102, 0xC0},
	{103, 0xBE},
	{104, 0x1C},
	{105, 0x09},
	{106, 0xC0},
	{107, 0xBF},
	{108, 0x1C},
	{109, 0x09},
	{110, 0xC0},
	{111, 0xC0},
	{112, 0x1C},
	{113, 0x09},
	{114, 0xC0},
	{115, 0xC1},
	{116, 0x18},
	{117, 0x09},
	{118, 0xC0},
	{119, 0xBB},
	{120, 0x58},
	{121, 0x70},
	{122, 0x00},
	{123, 0x2A},
	{124, 0x00},
	{125, 0x00},
	{126, 0x00},
	{127, 0x00},
	{  0, 0x0C},
	{  8, 0x10},
	{  9, 0x00},
	{ 10, 0x20},
	{ 11, 0xBA},
	{ 12, 0x00},
	{ 13, 0x00},
	{ 14, 0x00},
	{ 15, 0x00},
	{ 16, 0x10},
	{ 17, 0x00},
	{ 18, 0x20},
	{ 19, 0xC3},
	{ 20, 0x18},
	{ 21, 0x0B},
	{ 22, 0xA0},
	{ 23, 0xBB},
	{ 24, 0x1C},
	{ 25, 0x0C},
	{ 26, 0x00},
	{ 27, 0xBC},
	{ 28, 0x1C},
	{ 29, 0x0C},
	{ 30, 0x60},
	{ 31, 0xBD},
	{ 32, 0x1C},
	{ 33, 0x0C},
	{ 34, 0xC0},
	{ 35, 0xBE},
	{ 36, 0x1C},
	{ 37, 0x0D},
	{ 38, 0x20},
	{ 39, 0xBF},
	{ 40, 0x1C},
	{ 41, 0x0D},
	{ 42, 0x80},
	{ 43, 0xC0},
	{ 44, 0x1C},
	{ 45, 0x0D},
	{ 46, 0xE0},
	{ 47, 0xC1},
	{ 48, 0x1C},
	{ 49, 0x0E},
	{ 50, 0x40},
	{ 51, 0xC2},
	{ 52, 0x00},
	{ 53, 0x00},
	{ 54, 0x00},
	{ 55, 0x00},
	{ 56, 0x00},
	{ 57, 0x00},
	{ 58, 0x00},
	{ 59, 0x00},
	{ 60, 0x00},
	{ 61, 0x00},
	{ 62, 0x00},
	{ 63, 0x00},
	{ 64, 0x10},
	{ 65, 0x00},
	{ 66, 0x00},
	{ 67, 0xA4},
	{ 68, 0x58},
	{ 69, 0x60},
	{ 70, 0x00},
	{ 71, 0x53},
	{ 72, 0x6C},
	{ 73, 0x0A},
	{ 74, 0x40},
	{ 75, 0xAD},
	{ 76, 0x1C},
	{ 77, 0x09},
	{ 78, 0xE0},
	{ 79, 0xA4},
	{ 80, 0x00},
	{ 81, 0x00},
	{ 82, 0x00},
	{ 83, 0x00},
	{ 84, 0x00},
	{ 85, 0x00},
	{ 86, 0x00},
	{ 87, 0x00},
	{ 88, 0x10},
	{ 89, 0x00},
	{ 90, 0x00},
	{ 91, 0x54},
	{ 92, 0x44},
	{ 93, 0x00},
	{ 94, 0xC0},
	{ 95, 0x02},
	{ 96, 0x18},
	{ 97, 0x05},
	{ 98, 0x20},
	{ 99, 0xA4},
	{100, 0x44},
	{101, 0x00},
	{102, 0x00},
	{103, 0x02},
	{104, 0x18},
	{105, 0x05},
	{106, 0x20},
	{107, 0x54},
	{108, 0x44},
	{109, 0x00},
	{110, 0x00},
	{111, 0x00},
	{112, 0x00},
	{113, 0x00},
	{114, 0x00},
	{115, 0x00},
	{116, 0x00},
	{117, 0x00},
	{118, 0x00},
	{119, 0x00},
	{120, 0x10},
	{121, 0x00},
	{122, 0x00},
	{123, 0xA5},
	{124, 0x18},
	{125, 0x09},
	{126, 0xE0},
	{127, 0xA5},
	{  0, 0x0D},
	{  8, 0x58},
	{  9, 0x70},
	{ 10, 0x00},
	{ 11, 0x5C},
	{ 12, 0x58},
	{ 13, 0x60},
	{ 14, 0x00},
	{ 15, 0x5C},
	{ 16, 0x00},
	{ 17, 0x00},
	{ 18, 0x00},
	{ 19, 0x00},
	{ 20, 0x00},
	{ 21, 0x00},
	{ 22, 0x00},
	{ 23, 0x00},
	{ 24, 0x44},
	{ 25, 0x00},
	{ 26, 0xA0},
	{ 27, 0x01},
	{ 28, 0x44},
	{ 29, 0x00},
	{ 30, 0x00},
	{ 31, 0x01},
	{ 32, 0x10},
	{ 33, 0x00},
	{ 34, 0x00},
	{ 35, 0xA5},
	{ 36, 0x18},
	{ 37, 0x0A},
	{ 38, 0xE0},
	{ 39, 0xA5},
	{ 40, 0x1C},
	{ 41, 0x0B},
	{ 42, 0x20},
	{ 43, 0x92},
	{ 44, 0x00},
	{ 45, 0x00},
	{ 46, 0x00},
	{ 47, 0x00},
	{ 48, 0x00},
	{ 49, 0x00},
	{ 50, 0x00},
	{ 51, 0x00},
	{ 52, 0x00},
	{ 53, 0x00},
	{ 54, 0x00},
	{ 55, 0x00},
	{ 56, 0x10},
	{ 57, 0x00},
	{ 58, 0x00},
	{ 59, 0x8A},
	{ 60, 0x18},
	{ 61, 0x09},
	{ 62, 0xE0},
	{ 63, 0x8A},
	{ 64, 0x1C},
	{ 65, 0x00},
	{ 66, 0xA0},
	{ 67, 0xA4},
	{ 68, 0x00},
	{ 69, 0x00},
	{ 70, 0x00},
	{ 71, 0x00},
	{ 72, 0x00},
	{ 73, 0x00},
	{ 74, 0x00},
	{ 75, 0x00},
	{ 76, 0x00},
	{ 77, 0x00},
	{ 78, 0x00},
	{ 79, 0x00},
	{ 80, 0x10},
	{ 81, 0x00},
	{ 82, 0x00},
	{ 83, 0xA3},
	{ 84, 0x44},
	{ 85, 0x00},
	{ 86, 0xA0},
	{ 87, 0x10},
	{ 88, 0x18},
	{ 89, 0x09},
	{ 90, 0xE0},
	{ 91, 0xB8},
	{ 92, 0x58},
	{ 93, 0x70},
	{ 94, 0x00},
	{ 95, 0x06},
	{ 96, 0x00},
	{ 97, 0x00},
	{ 98, 0x00},
	{ 99, 0x00},
	{100, 0x00},
	{101, 0x00},
	{102, 0x00},
	{103, 0x00},
	{104, 0x00},
	{105, 0x00},
	{106, 0x00},
	{107, 0x00},
	{108, 0x10},
	{109, 0x00},
	{110, 0x00},
	{111, 0x54},
	{112, 0x18},
	{113, 0x0A},
	{114, 0xC0},
	{115, 0x54},
	{116, 0x00},
	{117, 0x00},
	{118, 0x00},
	{119, 0x00},
	{120, 0x00},
	{121, 0x00},
	{122, 0x00},
	{123, 0x00},
	{124, 0x00},
	{125, 0x00},
	{126, 0x00},
	{127, 0x00},
	{  0, 0x0E},
	{  8, 0x00},
	{  9, 0x00},
	{ 10, 0x00},
	{ 11, 0x00},
	{ 12, 0x00},
	{ 13, 0x00},
	{ 14, 0x00},
	{ 15, 0x00},
	{ 16, 0x00},
	{ 17, 0x00},
	{ 18, 0x00},
	{ 19, 0x00},
	{ 20, 0x00},
	{ 21, 0x00},
	{ 22, 0x00},
	{ 23, 0x00},
	{ 24, 0x00},
	{ 25, 0x00},
	{ 26, 0x00},
	{ 27, 0x00},
	{ 28, 0x44},
	{ 29, 0x00},
	{ 30, 0x00},
	{ 31, 0x15},
	{ 32, 0x18},
	{ 33, 0x05},
	{ 34, 0x20},
	{ 35, 0xA3},
	{ 36, 0x59},
	{ 37, 0x00},
	{ 38, 0x00},
	{ 39, 0x55},
	{ 40, 0x59},
	{ 41, 0x00},
	{ 42, 0x00},
	{ 43, 0x54},
	{ 44, 0x18},
	{ 45, 0x05},
	{ 46, 0x20},
	{ 47, 0xA3},
	{ 48, 0x00},
	{ 49, 0x00},
	{ 50, 0x00},
	{ 51, 0x00},
	{ 52, 0x44},
	{ 53, 0x00},
	{ 54, 0x60},
	{ 55, 0x03},
	{ 56, 0x44},
	{ 57, 0x00},
	{ 58, 0x80},
	{ 59, 0x05},
	{ 60, 0x00},
	{ 61, 0x00},
	{ 62, 0x00},
	{ 63, 0x00},
	{ 64, 0x44},
	{ 65, 0x00},
	{ 66, 0x00},
	{ 67, 0x05},
	{ 68, 0x00},
	{ 69, 0x00},
	{ 70, 0x00},
	{ 71, 0x00},
	{ 72, 0x58},
	{ 73, 0x60},
	{ 74, 0x00},
	{ 75, 0x55},
	{ 76, 0x44},
	{ 77, 0x00},
	{ 78, 0x00},
	{ 79, 0x02},
	{ 80, 0x58},
	{ 81, 0x60},
	{ 82, 0x00},
	{ 83, 0x54},
	{ 84, 0x44},
	{ 85, 0x00},
	{ 86, 0x00},
	{ 87, 0x00},
	{ 88, 0x18},
	{ 89, 0x09},
	{ 90, 0xE0},
	{ 91, 0xB8},
	{ 92, 0x58},
	{ 93, 0x70},
	{ 94, 0x00},
	{ 95, 0x29},
	{ 96, 0x20},
	{ 97, 0x0A},
	{ 98, 0x00},
	{ 99, 0x02},
	{100, 0x00},
	{101, 0x00},
	{102, 0x00},
	{103, 0x00},
	{104, 0x00},
	{105, 0x00},
	{106, 0x00},
	{107, 0x00},
	{108, 0x10},
	{109, 0x00},
	{110, 0x00},
	{111, 0x54},
	{112, 0x18},
	{113, 0x0A},
	{114, 0x00},
	{115, 0x54},
	{116, 0x1C},
	{117, 0x05},
	{118, 0x20},
	{119, 0xB8},
	{120, 0x00},
	{121, 0x00},
	{122, 0x00},
	{123, 0x00},
	{124, 0x00},
	{125, 0x00},
	{126, 0x00},
	{127, 0x00},
	{  0, 0x0F},
	{  8, 0x00},
	{  9, 0x00},
	{ 10, 0x00},
	{ 11, 0x00},
	{ 12, 0x10},
	{ 13, 0x00},
	{ 14, 0x00},
	{ 15, 0xB0},
	{ 16, 0x18},
	{ 17, 0x05},
	{ 18, 0x20},
	{ 19, 0xB0},
	{ 20, 0x00},
	{ 21, 0x00},
	{ 22, 0x00},
	{ 23, 0x00},
	{ 24, 0x00},
	{ 25, 0x00},
	{ 26, 0x00},
	{ 27, 0x00},
	{ 28, 0x00},
	{ 29, 0x00},
	{ 30, 0x00},
	{ 31, 0x00},
	{ 32, 0x20},
	{ 33, 0x0A},
	{ 34, 0x00},
	{ 35, 0x02},
	{ 36, 0x18},
	{ 37, 0x0B},
	{ 38, 0xC0},
	{ 39, 0xC3},
	{ 40, 0x1C},
	{ 41, 0x0A},
	{ 42, 0x00},
	{ 43, 0xBB},
	{ 44, 0x18},
	{ 45, 0x0C},
	{ 46, 0x20},
	{ 47, 0xC4},
	{ 48, 0x1C},
	{ 49, 0x0A},
	{ 50, 0x00},
	{ 51, 0xBC},
	{ 52, 0x18},
	{ 53, 0x0C},
	{ 54, 0x80},
	{ 55, 0xC5},
	{ 56, 0x20},
	{ 57, 0x0B},
	{ 58, 0xC0},
	{ 59, 0x02},
	{ 60, 0x1C},
	{ 61, 0x0A},
	{ 62, 0x00},
	{ 63, 0xBD},
	{ 64, 0x20},
	{ 65, 0x0C},
	{ 66, 0x20},
	{ 67, 0x02},
	{ 68, 0x18},
	{ 69, 0x0C},
	{ 70, 0xE0},
	{ 71, 0xC6},
	{ 72, 0x1C},
	{ 73, 0x0A},
	{ 74, 0x00},
	{ 75, 0xBE},
	{ 76, 0x20},
	{ 77, 0x0C},
	{ 78, 0x80},
	{ 79, 0x02},
	{ 80, 0x00},
	{ 81, 0x00},
	{ 82, 0x00},
	{ 83, 0x00},
	{ 84, 0x00},
	{ 85, 0x00},
	{ 86, 0x00},
	{ 87, 0x00},
	{ 88, 0x20},
	{ 89, 0x0C},
	{ 90, 0xE0},
	{ 91, 0x02},
	{ 92, 0x18},
	{ 93, 0x0D},
	{ 94, 0x40},
	{ 95, 0xC7},
	{ 96, 0x1C},
	{ 97, 0x0A},
	{ 98, 0x00},
	{ 99, 0xBF},
	{100, 0x00},
	{101, 0x00},
	{102, 0x00},
	{103, 0x00},
	{104, 0x00},
	{105, 0x00},
	{106, 0x00},
	{107, 0x00},
	{108, 0x00},
	{109, 0x00},
	{110, 0x00},
	{111, 0x00},
	{112, 0x20},
	{113, 0x0D},
	{114, 0x40},
	{115, 0x02},
	{116, 0x18},
	{117, 0x0D},
	{118, 0xA0},
	{119, 0xC8},
	{120, 0x1C},
	{121, 0x0A},
	{122, 0x00},
	{123, 0xC0},
	{124, 0x00},
	{125, 0x00},
	{126, 0x00},
	{127, 0x00},
	{  0, 0x10},
	{  8, 0x00},
	{  9, 0x00},
	{ 10, 0x00},
	{ 11, 0x00},
	{ 12, 0x00},
	{ 13, 0x00},
	{ 14, 0x00},
	{ 15, 0x00},
	{ 16, 0x20},
	{ 17, 0x0D},
	{ 18, 0xA0},
	{ 19, 0x02},
	{ 20, 0x18},
	{ 21, 0x0E},
	{ 22, 0x00},
	{ 23, 0xC9},
	{ 24, 0x1C},
	{ 25, 0x0A},
	{ 26, 0x00},
	{ 27, 0xC1},
	{ 28, 0x00},
	{ 29, 0x00},
	{ 30, 0x00},
	{ 31, 0x00},
	{ 32, 0x00},
	{ 33, 0x00},
	{ 34, 0x00},
	{ 35, 0x00},
	{ 36, 0x00},
	{ 37, 0x00},
	{ 38, 0x00},
	{ 39, 0x00},
	{ 40, 0x20},
	{ 41, 0x0E},
	{ 42, 0x00},
	{ 43, 0x02},
	{ 44, 0x18},
	{ 45, 0x0E},
	{ 46, 0x60},
	{ 47, 0xCA},
	{ 48, 0x1C},
	{ 49, 0x0A},
	{ 50, 0x00},
	{ 51, 0xC2},
	{ 52, 0x00},
	{ 53, 0x00},
	{ 54, 0x00},
	{ 55, 0x00},
	{ 56, 0x00},
	{ 57, 0x00},
	{ 58, 0x00},
	{ 59, 0x00},
	{ 60, 0x00},
	{ 61, 0x00},
	{ 62, 0x00},
	{ 63, 0x00},
	{ 64, 0x20},
	{ 65, 0x0E},
	{ 66, 0x60},
	{ 67, 0x02},
	{ 68, 0x58},
	{ 69, 0x60},
	{ 70, 0x00},
	{ 71, 0x5A},
	{ 72, 0x58},
	{ 73, 0x60},
	{ 74, 0x00},
	{ 75, 0x5B},
	{ 76, 0x00},
	{ 77, 0x00},
	{ 78, 0x00},
	{ 79, 0x00},
	{ 80, 0x00},
	{ 81, 0x00},
	{ 82, 0x00},
	{ 83, 0x00},
	{ 84, 0x10},
	{ 85, 0x00},
	{ 86, 0x00},
	{ 87, 0x51},
	{ 88, 0x10},
	{ 89, 0x00},
	{ 90, 0x00},
	{ 91, 0x52},
	{ 92, 0x18},
	{ 93, 0x0B},
	{ 94, 0xC0},
	{ 95, 0x51},
	{ 96, 0x1C},
	{ 97, 0x0B},
	{ 98, 0xE0},
	{ 99, 0x52},
	{100, 0x18},
	{101, 0x0C},
	{102, 0x20},
	{103, 0x51},
	{104, 0x1C},
	{105, 0x0C},
	{106, 0x40},
	{107, 0x52},
	{108, 0x18},
	{109, 0x0C},
	{110, 0x80},
	{111, 0x51},
	{112, 0x20},
	{113, 0x0B},
	{114, 0xE0},
	{115, 0x02},
	{116, 0x1C},
	{117, 0x0C},
	{118, 0xA0},
	{119, 0x52},
	{120, 0x20},
	{121, 0x0C},
	{122, 0x40},
	{123, 0x02},
	{124, 0x18},
	{125, 0x0C},
	{126, 0xE0},
	{127, 0x51},
	{  0, 0x11},
	{  8, 0x1C},
	{  9, 0x0D},

	{ 10, 0x00},
	{ 11, 0x52},
	{ 12, 0x20},
	{ 13, 0x0C},
	{ 14, 0xA0},
	{ 15, 0x02},
	{ 16, 0x18},
	{ 17, 0x0D},
	{ 18, 0x40},
	{ 19, 0x51},
	{ 20, 0x1C},
	{ 21, 0x0D},
	{ 22, 0x60},
	{ 23, 0x52},
	{ 24, 0x20},
	{ 25, 0x0D},
	{ 26, 0x00},
	{ 27, 0x02},
	{ 28, 0x18},
	{ 29, 0x0D},
	{ 30, 0xA0},
	{ 31, 0x51},
	{ 32, 0x1C},
	{ 33, 0x0D},
	{ 34, 0xC0},
	{ 35, 0x52},
	{ 36, 0x20},
	{ 37, 0x0D},
	{ 38, 0x60},
	{ 39, 0x02},
	{ 40, 0x18},
	{ 41, 0x0E},
	{ 42, 0x00},
	{ 43, 0x51},
	{ 44, 0x1C},
	{ 45, 0x0E},
	{ 46, 0x20},
	{ 47, 0x52},
	{ 48, 0x20},
	{ 49, 0x0D},
	{ 50, 0xC0},
	{ 51, 0x02},
	{ 52, 0x18},
	{ 53, 0x0E},
	{ 54, 0x60},
	{ 55, 0x51},
	{ 56, 0x1C},
	{ 57, 0x0E},
	{ 58, 0x80},
	{ 59, 0x52},
	{ 60, 0x20},
	{ 61, 0x0E},
	{ 62, 0x20},
	{ 63, 0x02},
	{ 64, 0x00},
	{ 65, 0x00},
	{ 66, 0x00},
	{ 67, 0x00},
	{ 68, 0x00},
	{ 69, 0x00},
	{ 70, 0x00},
	{ 71, 0x00},
	{ 72, 0x20},
	{ 73, 0x0E},
	{ 74, 0x80},
	{ 75, 0x02},
	{ 76, 0x18},
	{ 77, 0x0B},
	{ 78, 0xE0},
	{ 79, 0x5D},
	{ 80, 0x1C},
	{ 81, 0x0C},
	{ 82, 0x40},
	{ 83, 0x63},
	{ 84, 0x1C},
	{ 85, 0x0C},
	{ 86, 0xA0},
	{ 87, 0x69},
	{ 88, 0x1C},
	{ 89, 0x0D},
	{ 90, 0x00},
	{ 91, 0x6F},
	{ 92, 0x1C},
	{ 93, 0x0D},
	{ 94, 0x60},
	{ 95, 0x75},
	{ 96, 0x1C},
	{ 97, 0x0D},
	{ 98, 0xC0},
	{ 99, 0x7B},
	{100, 0x1C},
	{101, 0x0E},
	{102, 0x20},
	{103, 0x81},
	{104, 0x1C},
	{105, 0x0E},
	{106, 0x80},
	{107, 0x87},
	{108, 0x00},
	{109, 0x00},
	{110, 0x00},
	{111, 0x00},
	{112, 0x00},
	{113, 0x00},
	{114, 0x00},
	{115, 0x00},
	{116, 0x00},
	{117, 0x00},
	{118, 0x00},
	{119, 0x00},
	{120, 0x10},
	{121, 0x00},
	{122, 0x40},
	{123, 0x53},
	{124, 0x00},
	{125, 0x00},
	{126, 0x00},
	{127, 0x00},
	{  0, 0x12},
	{  8, 0x18},
	{  9, 0x05},
	{ 10, 0x40},
	{ 11, 0x53},
	{ 12, 0x18},
	{ 13, 0x05},
	{ 14, 0x40},
	{ 15, 0x50},
	{ 16, 0x58},
	{ 17, 0x60},
	{ 18, 0x00},
	{ 19, 0x2B},
	{ 20, 0x00},
	{ 21, 0x00},
	{ 22, 0x00},
	{ 23, 0x00},
	{ 24, 0x10},
	{ 25, 0x00},
	{ 26, 0x20},
	{ 27, 0xCB},
	{ 28, 0x10},
	{ 29, 0x00},
	{ 30, 0x20},
	{ 31, 0xCC},
	{ 32, 0x10},
	{ 33, 0x00},
	{ 34, 0x20},
	{ 35, 0xCD},
	{ 36, 0x10},
	{ 37, 0x00},
	{ 38, 0x20},
	{ 39, 0xCE},
	{ 40, 0x58},
	{ 41, 0x60},
	{ 42, 0x00},
	{ 43, 0x58},
	{ 44, 0x58},
	{ 45, 0x70},
	{ 46, 0x00},
	{ 47, 0x27},
	{ 48, 0x00},
	{ 49, 0x00},
	{ 50, 0x00},
	{ 51, 0x00},
	{ 52, 0x0C},
	{ 53, 0x07},
	{ 54, 0x80},
	{ 55, 0x0D},
	{ 56, 0x48},
	{ 57, 0x03},
	{ 58, 0xE0},
	{ 59, 0x00},
	{ 60, 0x00},
	{ 61, 0x00},
	{ 62, 0x00},
	{ 63, 0x00},
	{ 64, 0x18},
	{ 65, 0x05},
	{ 66, 0x40},
	{ 67, 0xCB},
	{ 68, 0x49},
	{ 69, 0x03},
	{ 70, 0xE0},
	{ 71, 0x00},
	{ 72, 0x00},
	{ 73, 0x00},
	{ 74, 0x00},
	{ 75, 0x00},
	{ 76, 0x00},
	{ 77, 0x00},
	{ 78, 0x00},
	{ 79, 0x00},
	{ 80, 0x10},
	{ 81, 0x00},
	{ 82, 0x20},
	{ 83, 0xCF},
	{ 84, 0x18},
	{ 85, 0x05},
	{ 86, 0x40},
	{ 87, 0xCF},
	{ 88, 0x00},
	{ 89, 0x00},
	{ 90, 0x00},
	{ 91, 0x00},
	{ 92, 0x0C},
	{ 93, 0x00},
	{ 94, 0x00},
	{ 95, 0x03},
	{ 96, 0x00},
	{ 97, 0x00},
	{ 98, 0x00},
	{ 99, 0x00},
	{100, 0x02},
	{101, 0x00},
	{102, 0x00},
	{103, 0x00},
	{104, 0x00},
	{105, 0x00},
	{106, 0x00},
	{107, 0x00},
};
#define main44_miniDSP_A_reg_values_COEFF_START   0
#define main44_miniDSP_A_reg_values_COEFF_SIZE    958
#define main44_miniDSP_A_reg_values_INST_START    958
#define main44_miniDSP_A_reg_values_INST_SIZE     2160

reg_value main44_miniDSP_D_reg_values[] = {
	{  0, 0x0},
	{  0x7F, 0x50},
	{  0, 0x01},
	{  8, 0xFF},
	{  9, 0xFF},
	{ 10, 0xFF},
	{ 11, 0x00},
	{ 12, 0x80},
	{ 13, 0x00},
	{ 14, 0x00},
	{ 15, 0x00},
	{ 16, 0x7F},
	{ 17, 0xF7},
	{ 18, 0x00},
	{ 19, 0x00},
	{ 20, 0x80},
	{ 21, 0x09},
	{ 22, 0x00},
	{ 23, 0x00},
	{ 24, 0x7F},
	{ 25, 0xEF},
	{ 26, 0x00},
	{ 27, 0x00},
	{ 28, 0xFF}, /*changed*/
	{ 29, 0xFF},
	{ 30, 0xFF},
	{ 31, 0x00},
	{ 32, 0x16},
	{ 33, 0xB5},
	{ 34, 0x43},
	{ 35, 0x00},
	{ 36, 0x40},
	{ 37, 0x00},
	{ 38, 0x00},
	{ 39, 0x00},
	{ 40, 0x20},
	{ 41, 0x00},
	{ 42, 0x00},
	{ 43, 0x00},
	{ 44, 0x00},
	{ 45, 0x00},
	{ 46, 0x00},
	{ 47, 0x00},
	{ 48, 0xD8},
	{ 49, 0x00},
	{ 50, 0x00},
	{ 51, 0x00},
	{ 52, 0xB0},
	{ 53, 0x00},
	{ 54, 0x00},
	{ 55, 0x00},
	{ 56, 0x40},
	{ 57, 0x00},
	{ 58, 0x00},
	{ 59, 0x00},
	{ 60, 0x7F},
	{ 61, 0xFF},
	{ 62, 0xFF},
	{ 63, 0x00},
	{ 64, 0x00},
	{ 65, 0x00},
	{ 66, 0x00},
	{ 67, 0x00},
	{ 68, 0x80},
	{ 69, 0x00},
	{ 70, 0x00},
	{ 71, 0x00},
	{ 72, 0x00},
	{ 73, 0x00},
	{ 74, 0x00},
	{ 75, 0x00},
	{ 76, 0x00},
	{ 77, 0x00},
	{ 78, 0x00},
	{ 79, 0x00},
	{ 80, 0xC0},
	{ 81, 0x00},
	{ 82, 0x00},
	{ 83, 0x00},
	{ 84, 0x00},
	{ 85, 0x0D},
	{ 86, 0x00},
	{ 87, 0x00},
	{ 88, 0x00},
	{ 89, 0x1C},
	{ 90, 0x00},
	{ 91, 0x00},
	{ 92, 0x00},
	{ 93, 0x3E},
	{ 94, 0x00},
	{ 95, 0x00},
	{ 96, 0x00},
	{ 97, 0x78},
	{ 98, 0x00},
	{ 99, 0x00},
	{100, 0x02},
	{101, 0x4C},
	{102, 0x00},
	{103, 0x00},
	{104, 0x00},
	{105, 0xD5},
	{106, 0x00},
	{107, 0x00},
	{108, 0x01},
	{109, 0x65},
	{110, 0x00},
	{111, 0x00},
	{112, 0x03},
	{113, 0xE9},
	{114, 0x00},
	{115, 0x00},
	{116, 0x07},
	{117, 0xCA},
	{118, 0x00},
	{119, 0x00},
	{120, 0xFF},
	{121, 0xEF},
	{122, 0x00},
	{123, 0x00},
	{124, 0xFE},
	{125, 0xEB},
	{126, 0x00},
	{127, 0x00},
	{  0, 0x02},
	{  8, 0xFF},
	{  9, 0xA8},
	{ 10, 0x00},
	{ 11, 0x00},
	{ 12, 0xFD},
	{ 13, 0x08},
	{ 14, 0x00},
	{ 15, 0x00},
	{ 16, 0xFF},
	{ 17, 0x5E},
	{ 18, 0x00},
	{ 19, 0x00},
	{ 20, 0xFF},
	{ 21, 0xD5},
	{ 22, 0x00},
	{ 23, 0x00},
	{ 24, 0xFE},
	{ 25, 0x36},
	{ 26, 0x00},
	{ 27, 0x00},
	{ 28, 0xFA},
	{ 29, 0xAC},
	{ 30, 0x00},
	{ 31, 0x00},
	{ 32, 0xF2},
	{ 33, 0xA3},
	{ 34, 0x00},
	{ 35, 0x00},
	{ 36, 0x28},
	{ 37, 0xAB},
	{ 38, 0x00},
	{ 39, 0x00},
	{ 40, 0x3F},
	{ 41, 0xFF},
	{ 42, 0x00},
	{ 43, 0x00},
	{ 44, 0xFF},
	{ 45, 0x98},
	{ 46, 0x00},
	{ 47, 0x00},
	{ 48, 0xF6},
	{ 49, 0xF9},
	{ 50, 0x00},
	{ 51, 0x00},
	{ 52, 0x26},
	{ 53, 0xFB},
	{ 54, 0x00},
	{ 55, 0x00},
	{ 56, 0x02},
	{ 57, 0x72},
	{ 58, 0x00},
	{ 59, 0x00},
	{ 60, 0x40},
	{ 61, 0x02},
	{ 62, 0x00},
	{ 63, 0x00},
	{ 64, 0xFB},
	{ 65, 0xCB},
	{ 66, 0x00},
	{ 67, 0x00},
	{ 68, 0x20},
	{ 69, 0xA7},
	{ 70, 0x00},
	{ 71, 0x00},
	{ 72, 0xFF},
	{ 73, 0x6A},
	{ 74, 0x00},
	{ 75, 0x00},
	{ 76, 0x3A},
	{ 77, 0x0F},
	{ 78, 0x00},
	{ 79, 0x00},
	{  0, 0x09},
	{ 72, 0xFF},
	{ 73, 0xFF},
	{ 74, 0xFF},
	{ 75, 0x00},
	{ 76, 0x80},
	{ 77, 0x00},
	{ 78, 0x00},
	{ 79, 0x00},
	{ 80, 0x7F},
	{ 81, 0xF7},
	{ 82, 0x00},
	{ 83, 0x00},
	{ 84, 0x80},
	{ 85, 0x09},
	{ 86, 0x00},
	{ 87, 0x00},
	{ 88, 0x7F},
	{ 89, 0xEF},
	{ 90, 0x00},
	{ 91, 0x00},
	{ 92, 0xFF},
	{ 93, 0xFF},
	{ 94, 0xFF},
	{ 95, 0x00},
	{ 96, 0x16},
	{ 97, 0xB5},
	{ 98, 0x43},
	{ 99, 0x00},
	{100, 0x40},
	{101, 0x00},
	{102, 0x00},
	{103, 0x00},
	{104, 0x20},
	{105, 0x00},
	{106, 0x00},
	{107, 0x00},
	{108, 0x00},
	{109, 0x00},
	{110, 0x00},
	{111, 0x00},
	{112, 0xD8},
	{113, 0x00},
	{114, 0x00},
	{115, 0x00},
	{116, 0xB0},
	{117, 0x00},
	{118, 0x00},
	{119, 0x00},
	{120, 0x40},
	{121, 0x00},
	{122, 0x00},
	{123, 0x00},
	{124, 0x7F},
	{125, 0xFF},
	{126, 0xFF},
	{127, 0x00},
	{  0, 0x0A},
	{  8, 0x00},
	{  9, 0x00},
	{ 10, 0x00},
	{ 11, 0x00},
	{ 12, 0x80},
	{ 13, 0x00},
	{ 14, 0x00},
	{ 15, 0x00},
	{ 16, 0x00},
	{ 17, 0x00},
	{ 18, 0x00},
	{ 19, 0x00},
	{ 20, 0x00},
	{ 21, 0x00},
	{ 22, 0x00},
	{ 23, 0x00},
	{ 24, 0xC0},
	{ 25, 0x00},
	{ 26, 0x00},
	{ 27, 0x00},
	{ 28, 0x00},
	{ 29, 0x0D},
	{ 30, 0x00},
	{ 31, 0x00},
	{ 32, 0x00},
	{ 33, 0x1C},
	{ 34, 0x00},
	{ 35, 0x00},
	{ 36, 0x00},
	{ 37, 0x3E},
	{ 38, 0x00},
	{ 39, 0x00},
	{ 40, 0x00},
	{ 41, 0x78},
	{ 42, 0x00},
	{ 43, 0x00},
	{ 44, 0x02},
	{ 45, 0x4C},
	{ 46, 0x00},
	{ 47, 0x00},
	{ 48, 0x00},
	{ 49, 0xD5},
	{ 50, 0x00},
	{ 51, 0x00},
	{ 52, 0x01},
	{ 53, 0x65},
	{ 54, 0x00},
	{ 55, 0x00},
	{ 56, 0x03},
	{ 57, 0xE9},
	{ 58, 0x00},
	{ 59, 0x00},
	{ 60, 0x07},
	{ 61, 0xCA},
	{ 62, 0x00},
	{ 63, 0x00},
	{ 64, 0xFF},
	{ 65, 0xEF},
	{ 66, 0x00},
	{ 67, 0x00},
	{ 68, 0xFE},
	{ 69, 0xEB},
	{ 70, 0x00},
	{ 71, 0x00},
	{ 72, 0xFF},
	{ 73, 0xA8},
	{ 74, 0x00},
	{ 75, 0x00},
	{ 76, 0xFD},
	{ 77, 0x08},
	{ 78, 0x00},
	{ 79, 0x00},
	{ 80, 0xFF},
	{ 81, 0x5E},
	{ 82, 0x00},
	{ 83, 0x00},
	{ 84, 0xFF},
	{ 85, 0xD5},
	{ 86, 0x00},
	{ 87, 0x00},
	{ 88, 0xFE},
	{ 89, 0x36},
	{ 90, 0x00},
	{ 91, 0x00},
	{ 92, 0xFA},
	{ 93, 0xAC},
	{ 94, 0x00},
	{ 95, 0x00},
	{ 96, 0xF2},
	{ 97, 0xA3},
	{ 98, 0x00},
	{ 99, 0x00},
	{100, 0x28},
	{101, 0xAB},
	{102, 0x00},
	{103, 0x00},
	{104, 0x3F},
	{105, 0xFF},
	{106, 0x00},
	{107, 0x00},
	{108, 0xFF},
	{109, 0x98},
	{110, 0x00},
	{111, 0x00},
	{112, 0xF6},
	{113, 0xF9},
	{114, 0x00},
	{115, 0x00},
	{116, 0x26},
	{117, 0xFB},
	{118, 0x00},
	{119, 0x00},
	{120, 0x02},
	{121, 0x72},
	{122, 0x00},
	{123, 0x00},
	{124, 0x40},
	{125, 0x02},
	{126, 0x00},
	{127, 0x00},
	{  0, 0x0B},
	{  8, 0xFB},
	{  9, 0xCB},
	{ 10, 0x00},
	{ 11, 0x00},
	{ 12, 0x20},
	{ 13, 0xA7},
	{ 14, 0x00},
	{ 15, 0x00},
	{ 16, 0xFF},
	{ 17, 0x6A},
	{ 18, 0x00},
	{ 19, 0x00},
	{ 20, 0x3A},
	{ 21, 0x0F},
	{ 22, 0x00},
	{ 23, 0x00},
	{  0, 0x0},
	{  0x7F, 0x3C},
	{  0, 0x01},
	{  8, 0xC0},
	{  9, 0x00},
	{ 10, 0x00},
	{ 11, 0x00},
	{ 12, 0xFF},
	{ 13, 0x80},
	{ 14, 0x00},
	{ 15, 0x00},
	{ 16, 0x00},
	{ 17, 0x20},
	{ 18, 0x00},
	{ 19, 0x00},
	{ 20, 0x00},
	{ 21, 0x00},
	{ 22, 0x00},
	{ 23, 0x00},
	{ 24, 0x40},
	{ 25, 0x00},
	{ 26, 0x00},
	{ 27, 0x00},
	{ 28, 0x20},
	{ 29, 0x00},
	{ 30, 0x00},
	{ 31, 0x00},
	{ 32, 0x00},
	{ 33, 0x00},
	{ 34, 0x00},
	{ 35, 0x00},
	{ 36, 0xD8},
	{ 37, 0x00},
	{ 38, 0x00},
	{ 39, 0x00},
	{ 40, 0xB0},
	{ 41, 0x00},
	{ 42, 0x00},
	{ 43, 0x00},
	{ 44, 0x01},
	{ 45, 0x99},
	{ 46, 0x9A},
	{ 47, 0x00},
	{ 48, 0x00},
	{ 49, 0xCC},
	{ 50, 0xCD},
	{ 51, 0x00},
	{ 52, 0xB8},
	{ 53, 0x8C},
	{ 54, 0x96},
	{ 55, 0x00},
	{ 56, 0x6B},
	{ 57, 0x2D},
	{ 58, 0x1E},
	{ 59, 0x00},
	{ 60, 0x5C},
	{ 61, 0x46},
	{ 62, 0x4B},
	{ 63, 0x00},
	{ 64, 0x15},
	{ 65, 0x55},
	{ 66, 0x55},
	{ 67, 0x00},
	{ 68, 0x40},
	{ 69, 0x00},
	{ 70, 0x00},
	{ 71, 0x00},
	{ 72, 0x00},
	{ 73, 0x00},
	{ 74, 0x00},
	{ 75, 0x00},
	{ 76, 0x00},
	{ 77, 0x00},
	{ 78, 0x00},
	{ 79, 0x00},
	{ 80, 0x00},
	{ 81, 0x00},
	{ 82, 0x00},
	{ 83, 0x00},
	{ 84, 0xE0},
	{ 85, 0x00},
	{ 86, 0x00},
	{ 87, 0x00},
	{ 88, 0x48},
	{ 89, 0x00},
	{ 90, 0x00},
	{ 91, 0x00},
	{ 92, 0x60},
	{ 93, 0x00},
	{ 94, 0x00},
	{ 95, 0x00},
	{ 96, 0x20},
	{ 97, 0x00},
	{ 98, 0x00},
	{ 99, 0x00},
	{100, 0x20},
	{101, 0xC8},
	{102, 0xB6},
	{103, 0x00},
	{104, 0x00},
	{105, 0x00},
	{106, 0x00},
	{107, 0x00},
	{108, 0xC0},
	{109, 0x88},
	{110, 0x0C},
	{111, 0x00},
	{112, 0x1E},
	{113, 0xB0},
	{114, 0xA3},
	{115, 0x00},
	{116, 0x00},
	{117, 0x00},
	{118, 0x00},
	{119, 0x00},
	{120, 0x00},
	{121, 0x00},
	{122, 0x00},
	{123, 0x00},
	{124, 0x3F},
	{125, 0x77},
	{126, 0xF4},
	{127, 0x00},
	{  0, 0x02},
	{  8, 0xE0},
	{  9, 0x86},
	{ 10, 0xA8},
	{ 11, 0x00},
	{ 12, 0x00},
	{ 13, 0x00},
	{ 14, 0x00},
	{ 15, 0x00},
	{ 16, 0x22},
	{ 17, 0x58},
	{ 18, 0x30},
	{ 19, 0x00},
	{ 20, 0x00},
	{ 21, 0x00},
	{ 22, 0x00},
	{ 23, 0x00},
	{ 24, 0xC1},
	{ 25, 0xA1},
	{ 26, 0x93},
	{ 27, 0x00},
	{ 28, 0x1C},
	{ 29, 0x15},
	{ 30, 0x25},
	{ 31, 0x00},
	{ 32, 0x00},
	{ 33, 0x00},
	{ 34, 0x00},
	{ 35, 0x00},
	{ 36, 0x00},
	{ 37, 0x00},
	{ 38, 0x00},
	{ 39, 0x00},
	{ 40, 0x3E},
	{ 41, 0x5E},
	{ 42, 0x6D},
	{ 43, 0x00},
	{ 44, 0xE1},
	{ 45, 0x92},
	{ 46, 0xAB},
	{ 47, 0x00},
	{ 48, 0x00},
	{ 49, 0x00},
	{ 50, 0x00},
	{ 51, 0x00},
	{ 52, 0x27},
	{ 53, 0x50},
	{ 54, 0xC7},
	{ 55, 0x00},
	{ 56, 0x00},
	{ 57, 0x00},
	{ 58, 0x00},
	{ 59, 0x00},
	{ 60, 0xC5},
	{ 61, 0x69},
	{ 62, 0xDD},
	{ 63, 0x00},
	{ 64, 0x13},
	{ 65, 0xC6},
	{ 66, 0xC7},
	{ 67, 0x00},
	{ 68, 0x00},
	{ 69, 0x00},
	{ 70, 0x00},
	{ 71, 0x00},
	{ 72, 0x00},
	{ 73, 0x00},
	{ 74, 0x00},
	{ 75, 0x00},
	{ 76, 0x3A},
	{ 77, 0x96},
	{ 78, 0x23},
	{ 79, 0x00},
	{ 80, 0xE4},
	{ 81, 0xE8},
	{ 82, 0x72},
	{ 83, 0x00},
	{ 84, 0x00},
	{ 85, 0x00},
	{ 86, 0x00},
	{ 87, 0x00},
	{ 88, 0x33},
	{ 89, 0x86},
	{ 90, 0xC5},
	{ 91, 0x00},
	{ 92, 0x00},
	{ 93, 0x00},
	{ 94, 0x00},
	{ 95, 0x00},
	{ 96, 0xD1},
	{ 97, 0xC6},
	{ 98, 0x99},
	{ 99, 0x00},
	{100, 0xFF},
	{101, 0x5F},
	{102, 0x8F},
	{103, 0x00},
	{104, 0x00},
	{105, 0x00},
	{106, 0x00},
	{107, 0x00},
	{108, 0x00},
	{109, 0x00},
	{110, 0x00},
	{111, 0x00},
	{112, 0x2E},
	{113, 0x39},
	{114, 0x67},
	{115, 0x00},
	{116, 0xED},
	{117, 0x19},
	{118, 0xAC},
	{119, 0x00},
	{120, 0x00},
	{121, 0x00},
	{122, 0x00},
	{123, 0x00},
	{124, 0x4E},
	{125, 0xA5},
	{126, 0x44},
	{127, 0x00},
	{  0, 0x03},
	{  8, 0x00},
	{  9, 0x00},
	{ 10, 0x00},
	{ 11, 0x00},
	{ 12, 0xF7},
	{ 13, 0x89},
	{ 14, 0x02},
	{ 15, 0x00},
	{ 16, 0xD2},
	{ 17, 0x0F},
	{ 18, 0x57},
	{ 19, 0x00},
	{ 20, 0x00},
	{ 21, 0x00},
	{ 22, 0x00},
	{ 23, 0x00},
	{ 24, 0x00},
	{ 25, 0x00},
	{ 26, 0x00},
	{ 27, 0x00},
	{ 28, 0x08},
	{ 29, 0x76},
	{ 30, 0xFE},
	{ 31, 0x00},
	{ 32, 0xFF},
	{ 33, 0x4B},
	{ 34, 0x64},
	{ 35, 0x00},
	{ 36, 0x00},
	{ 37, 0x00},
	{ 38, 0x00},
	{ 39, 0x00},
	{ 40, 0xC0},
	{ 41, 0x00},
	{ 42, 0x00},
	{ 43, 0x00},
	{  0, 0x0},
	{  0x7F, 0x78},
	{  0, 0x01},
	{  8, 0x00},
	{  9, 0x00},
	{ 10, 0x00},
	{ 11, 0x00},
	{ 12, 0x00},
	{ 13, 0x00},
	{ 14, 0x00},
	{ 15, 0x00},
	{ 16, 0x04},
	{ 17, 0x00},
	{ 18, 0x00},
	{ 19, 0x00},
	{ 20, 0x04},
	{ 21, 0x00},
	{ 22, 0x20},
	{ 23, 0x01},
	{ 24, 0x58},
	{ 25, 0x60},
	{ 26, 0x08},
	{ 27, 0x44},
	{ 28, 0x60},
	{ 29, 0x60},
	{ 30, 0x00},
	{ 31, 0x00},
	{ 32, 0x58},
	{ 33, 0x60},
	{ 34, 0x00},
	{ 35, 0x0E},
	{ 36, 0x00},
	{ 37, 0x00},
	{ 38, 0x00},
	{ 39, 0x00},
	{ 40, 0x44},
	{ 41, 0x00},
	{ 42, 0xC0},
	{ 43, 0x16},
	{ 44, 0x08},
	{ 45, 0x00},
	{ 46, 0x00},
	{ 47, 0x75},
	{ 48, 0x08},
	{ 49, 0x00},
	{ 50, 0x20},
	{ 51, 0xB5},
	{ 52, 0x08},
	{ 53, 0x00},
	{ 54, 0x00},
	{ 55, 0x74},
	{ 56, 0x08},
	{ 57, 0x00},
	{ 58, 0x20},
	{ 59, 0xB4},
	{ 60, 0x08},
	{ 61, 0x00},
	{ 62, 0x00},
	{ 63, 0x73},
	{ 64, 0x08},
	{ 65, 0x00},
	{ 66, 0x20},
	{ 67, 0xB3},
	{ 68, 0x08},
	{ 69, 0x00},
	{ 70, 0x00},
	{ 71, 0x72},
	{ 72, 0x08},
	{ 73, 0x00},
	{ 74, 0x20},
	{ 75, 0xB2},
	{ 76, 0x08},
	{ 77, 0x00},
	{ 78, 0x00},
	{ 79, 0x71},
	{ 80, 0x08},
	{ 81, 0x00},
	{ 82, 0x20},
	{ 83, 0xB1},
	{ 84, 0x08},
	{ 85, 0x00},
	{ 86, 0x00},
	{ 87, 0x70},
	{ 88, 0x08},
	{ 89, 0x00},
	{ 90, 0x20},
	{ 91, 0xB0},
	{ 92, 0x08},
	{ 93, 0x00},
	{ 94, 0x00},
	{ 95, 0x6F},
	{ 96, 0x08},
	{ 97, 0x00},
	{ 98, 0x20},
	{ 99, 0xAF},
	{100, 0x08},
	{101, 0x00},
	{102, 0x00},
	{103, 0x6E},
	{104, 0x08},
	{105, 0x00},
	{106, 0x20},
	{107, 0xAE},
	{108, 0x00},
	{109, 0x00},
	{110, 0x00},
	{111, 0x00},
	{112, 0x00},
	{113, 0x00},
	{114, 0x00},
	{115, 0x00},
	{116, 0x00},
	{117, 0x00},
	{118, 0x00},
	{119, 0x00},
	{120, 0x00},
	{121, 0x00},
	{122, 0x00},
	{123, 0x00},
	{124, 0x00},
	{125, 0x00},
	{126, 0x00},
	{127, 0x00},
	{  0, 0x02},
	{  8, 0x44},
	{  9, 0x00},
	{ 10, 0x00},
	{ 11, 0x06},
	{ 12, 0x21},
	{ 13, 0x08},
	{ 14, 0x80},
	{ 15, 0x00},
	{ 16, 0x4B},
	{ 17, 0x00},
	{ 18, 0xC0},
	{ 19, 0x00},
	{ 20, 0x4B},
	{ 21, 0x00},
	{ 22, 0xE0},
	{ 23, 0x00},
	{ 24, 0x00},
	{ 25, 0x00},
	{ 26, 0x40},
	{ 27, 0x48},
	{ 28, 0x0C},
	{ 29, 0x00},
	{ 30, 0x00},
	{ 31, 0x00},
	{ 32, 0x0C},
	{ 33, 0x00},
	{ 34, 0x20},
	{ 35, 0x00},
	{ 36, 0x58},
	{ 37, 0x60},
	{ 38, 0x08},
	{ 39, 0x03},
	{ 40, 0x5C},
	{ 41, 0x60},
	{ 42, 0x00},
	{ 43, 0x27},
	{ 44, 0x59},
	{ 45, 0x00},
	{ 46, 0x08},
	{ 47, 0x01},
	{ 48, 0x58},
	{ 49, 0x70},
	{ 50, 0x08},
	{ 51, 0x02},
	{ 52, 0x10},
	{ 53, 0x00},
	{ 54, 0x00},
	{ 55, 0x26},
	{ 56, 0x08},
	{ 57, 0x07},
	{ 58, 0x60},
	{ 59, 0x27},
	{ 60, 0x44},
	{ 61, 0x00},
	{ 62, 0x80},
	{ 63, 0x01},
	{ 64, 0x44},
	{ 65, 0x00},
	{ 66, 0x00},
	{ 67, 0x01},
	{ 68, 0x10},
	{ 69, 0x00},
	{ 70, 0x00},
	{ 71, 0x26},
	{ 72, 0x58},
	{ 73, 0x60},
	{ 74, 0x08},
	{ 75, 0x09},
	{ 76, 0x58},
	{ 77, 0x60},
	{ 78, 0x08},
	{ 79, 0x0A},
	{ 80, 0x48},
	{ 81, 0x03},
	{ 82, 0xC0},
	{ 83, 0x00},
	{ 84, 0x58},
	{ 85, 0x70},
	{ 86, 0x08},
	{ 87, 0x04},
	{ 88, 0x10},
	{ 89, 0x00},
	{ 90, 0x00},
	{ 91, 0x28},
	{ 92, 0x59},
	{ 93, 0xA0},
	{ 94, 0x00},
	{ 95, 0x07},
	{ 96, 0x00},
	{ 97, 0x00},
	{ 98, 0x00},
	{ 99, 0x00},
	{100, 0x5D},
	{101, 0xA0},
	{102, 0x00},
	{103, 0x28},
	{104, 0x58},
	{105, 0x70},
	{106, 0x00},
	{107, 0x07},
	{108, 0x44},
	{109, 0x00},
	{110, 0xC0},
	{111, 0x0D},
	{112, 0x58},
	{113, 0x60},
	{114, 0x00},
	{115, 0x07},
	{116, 0x44},
	{117, 0x00},
	{118, 0xC0},
	{119, 0x03},
	{120, 0x21},
	{121, 0x00},
	{122, 0x80},
	{123, 0x02},
	{124, 0x00},
	{125, 0x00},
	{126, 0x00},
	{127, 0x00},
	{  0, 0x03},
	{  8, 0x44},
	{  9, 0x00},
	{ 10, 0x00},
	{ 11, 0x0D},
	{ 12, 0x00},
	{ 13, 0x00},
	{ 14, 0x00},
	{ 15, 0x00},
	{ 16, 0x00},
	{ 17, 0x00},
	{ 18, 0x00},
	{ 19, 0x00},
	{ 20, 0x21},
	{ 21, 0x00},
	{ 22, 0x80},
	{ 23, 0x02},
	{ 24, 0x00},
	{ 25, 0x00},
	{ 26, 0x00},
	{ 27, 0x00},
	{ 28, 0x00},
	{ 29, 0x00},
	{ 30, 0x00},
	{ 31, 0x00},
	{ 32, 0x00},
	{ 33, 0x00},
	{ 34, 0x00},
	{ 35, 0x00},
	{ 36, 0x00},
	{ 37, 0x00},
	{ 38, 0x00},
	{ 39, 0x00},
	{ 40, 0x44},
	{ 41, 0x00},
	{ 42, 0x00},
	{ 43, 0x0A},
	{ 44, 0x5C},
	{ 45, 0x70},
	{ 46, 0x00},
	{ 47, 0x28},
	{ 48, 0x00},
	{ 49, 0x00},
	{ 50, 0x00},
	{ 51, 0x00},
	{ 52, 0x00},
	{ 53, 0x00},
	{ 54, 0x00},
	{ 55, 0x00},
	{ 56, 0x00},
	{ 57, 0x00},
	{ 58, 0x00},
	{ 59, 0x00},
	{ 60, 0x21},
	{ 61, 0x00},
	{ 62, 0x80},
	{ 63, 0x02},
	{ 64, 0x5C},
	{ 65, 0x60},
	{ 66, 0x00},
	{ 67, 0x27},
	{ 68, 0x00},
	{ 69, 0x00},
	{ 70, 0x00},
	{ 71, 0x00},
	{ 72, 0x00},
	{ 73, 0x00},
	{ 74, 0x00},
	{ 75, 0x00},
	{ 76, 0x00},
	{ 77, 0x00},
	{ 78, 0x00},
	{ 79, 0x00},
	{ 80, 0x10},
	{ 81, 0x00},
	{ 82, 0x00},
	{ 83, 0x26},
	{ 84, 0x64},
	{ 85, 0x50},
	{ 86, 0x28},
	{ 87, 0x04},
	{ 88, 0x49},
	{ 89, 0x03},
	{ 90, 0xC0},
	{ 91, 0x00},
	{ 92, 0x64},
	{ 93, 0x40},
	{ 94, 0xA8},
	{ 95, 0x0E},
	{ 96, 0x58},
	{ 97, 0x70},
	{ 98, 0x08},
	{ 99, 0x0F},
	{100, 0x00},
	{101, 0x00},
	{102, 0x00},
	{103, 0x00},
	{104, 0x58},
	{105, 0x60},
	{106, 0x08},
	{107, 0x0C},
	{108, 0x39},
	{109, 0x01},
	{110, 0x60},
	{111, 0x28},
	{112, 0x21},
	{113, 0x02},
	{114, 0x00},
	{115, 0x02},
	{116, 0x25},
	{117, 0x02},
	{118, 0x00},
	{119, 0x00},
	{120, 0x58},
	{121, 0x70},
	{122, 0x08},
	{123, 0x0D},
	{124, 0x00},
	{125, 0x00},
	{126, 0x00},
	{127, 0x00},
	{  0, 0x04},
	{  8, 0x25},
	{  9, 0x02},
	{ 10, 0x00},
	{ 11, 0x00},
	{ 12, 0x58},
	{ 13, 0x70},
	{ 14, 0x00},
	{ 15, 0x0F},
	{ 16, 0x19},
	{ 17, 0x02},
	{ 18, 0x80},
	{ 19, 0x27},
	{ 20, 0x00},
	{ 21, 0x00},
	{ 22, 0x00},
	{ 23, 0x00},
	{ 24, 0x10},
	{ 25, 0x00},
	{ 26, 0x40},
	{ 27, 0x2A},
	{ 28, 0x10},
	{ 29, 0x00},
	{ 30, 0x40},
	{ 31, 0x2B},
	{ 32, 0x10},
	{ 33, 0x00},
	{ 34, 0x80},
	{ 35, 0x29},
	{ 36, 0x19},
	{ 37, 0x02},
	{ 38, 0x60},
	{ 39, 0x2A},
	{ 40, 0x08},
	{ 41, 0x07},
	{ 42, 0x60},
	{ 43, 0x29},
	{ 44, 0x19},
	{ 45, 0x02},
	{ 46, 0x60},
	{ 47, 0x2B},
	{ 48, 0x48},
	{ 49, 0x03},
	{ 50, 0xC0},
	{ 51, 0x00},
	{ 52, 0x10},
	{ 53, 0x00},
	{ 54, 0x00},
	{ 55, 0x28},
	{ 56, 0x1D},
	{ 57, 0x02},
	{ 58, 0xE0},
	{ 59, 0x2A},
	{ 60, 0x19},
	{ 61, 0x03},
	{ 62, 0x40},
	{ 63, 0x2A},
	{ 64, 0x1D},
	{ 65, 0x03},
	{ 66, 0xC0},
	{ 67, 0x2B},
	{ 68, 0x5C},
	{ 69, 0x60},
	{ 70, 0x00},
	{ 71, 0x28},
	{ 72, 0x21},
	{ 73, 0x03},
	{ 74, 0x00},
	{ 75, 0x00},
	{ 76, 0x1D},
	{ 77, 0x02},
	{ 78, 0xE0},
	{ 79, 0x2B},
	{ 80, 0x21},
	{ 81, 0x03},
	{ 82, 0x60},
	{ 83, 0x00},
	{ 84, 0x19},
	{ 85, 0x03},
	{ 86, 0xC0},
	{ 87, 0x2A},
	{ 88, 0x1D},
	{ 89, 0x03},
	{ 90, 0x40},
	{ 91, 0x2B},
	{ 92, 0x21},
	{ 93, 0x03},
	{ 94, 0x80},
	{ 95, 0x00},
	{ 96, 0x58},
	{ 97, 0x60},
	{ 98, 0x08},
	{ 99, 0x1C},
	{100, 0x00},
	{101, 0x00},
	{102, 0x00},
	{103, 0x00},
	{104, 0x21},
	{105, 0x03},
	{106, 0xE0},
	{107, 0x00},
	{108, 0x49},
	{109, 0x03},
	{110, 0xC0},
	{111, 0x00},
	{112, 0x21},
	{113, 0x02},
	{114, 0x20},
	{115, 0x02},
	{116, 0x58},
	{117, 0x70},
	{118, 0x08},
	{119, 0x15},
	{120, 0x00},
	{121, 0x00},
	{122, 0xA0},
	{123, 0x18},
	{124, 0x00},
	{125, 0x00},
	{126, 0x00},
	{127, 0x00},
	{  0, 0x05},
	{  8, 0x58},
	{  9, 0x60},
	{ 10, 0x08},
	{ 11, 0x16},
	{ 12, 0x39},
	{ 13, 0x02},
	{ 14, 0x20},
	{ 15, 0x28},
	{ 16, 0x21},
	{ 17, 0x02},
	{ 18, 0x40},
	{ 19, 0x01},
	{ 20, 0x25},
	{ 21, 0x02},
	{ 22, 0x40},
	{ 23, 0x04},
	{ 24, 0x00},
	{ 25, 0x00},
	{ 26, 0x00},
	{ 27, 0x00},
	{ 28, 0x00},
	{ 29, 0x00},
	{ 30, 0x00},
	{ 31, 0x00},
	{ 32, 0x48},
	{ 33, 0x03},
	{ 34, 0xC0},
	{ 35, 0x00},
	{ 36, 0x21},
	{ 37, 0x03},
	{ 38, 0x80},
	{ 39, 0x03},
	{ 40, 0x49},
	{ 41, 0x03},
	{ 42, 0xC0},
	{ 43, 0x00},
	{ 44, 0x5C},
	{ 45, 0x60},
	{ 46, 0x00},
	{ 47, 0x00},
	{ 48, 0x19},
	{ 49, 0x03},
	{ 50, 0x20},
	{ 51, 0x03},
	{ 52, 0x1D},
	{ 53, 0x03},
	{ 54, 0x60},
	{ 55, 0x04},
	{ 56, 0x1D},
	{ 57, 0x03},
	{ 58, 0xA0},
	{ 59, 0x06},
	{ 60, 0x4D},
	{ 61, 0x03},
	{ 62, 0x00},
	{ 63, 0x02},
	{ 64, 0x1D},
	{ 65, 0x03},
	{ 66, 0xE0},
	{ 67, 0x07},
	{ 68, 0x00},
	{ 69, 0x00},
	{ 70, 0x00},
	{ 71, 0x00},
	{ 72, 0x25},
	{ 73, 0x03},
	{ 74, 0x80},
	{ 75, 0x02},
	{ 76, 0x19},
	{ 77, 0x04},
	{ 78, 0x40},
	{ 79, 0x06},
	{ 80, 0x1D},
	{ 81, 0x04},
	{ 82, 0x80},
	{ 83, 0x07},
	{ 84, 0x1D},
	{ 85, 0x04},
	{ 86, 0xC0},
	{ 87, 0x09},
	{ 88, 0x4D},
	{ 89, 0x04},
	{ 90, 0x20},
	{ 91, 0x05},
	{ 92, 0x1D},
	{ 93, 0x05},
	{ 94, 0x00},
	{ 95, 0x0A},
	{ 96, 0x00},
	{ 97, 0x00},
	{ 98, 0x00},
	{ 99, 0x00},
	{100, 0x25},
	{101, 0x04},
	{102, 0xA0},
	{103, 0x02},
	{104, 0x19},
	{105, 0x05},
	{106, 0x60},
	{107, 0x09},
	{108, 0x1D},
	{109, 0x05},
	{110, 0xA0},
	{111, 0x0A},
	{112, 0x1D},
	{113, 0x05},
	{114, 0xE0},
	{115, 0x0C},
	{116, 0x4D},
	{117, 0x05},
	{118, 0x40},
	{119, 0x08},
	{120, 0x1D},
	{121, 0x06},
	{122, 0x20},
	{123, 0x0D},
	{124, 0x00},
	{125, 0x00},
	{126, 0x00},
	{127, 0x00},
	{  0, 0x06},
	{  8, 0x25},
	{  9, 0x05},
	{ 10, 0xC0},
	{ 11, 0x02},
	{ 12, 0x19},
	{ 13, 0x06},
	{ 14, 0x80},
	{ 15, 0x0C},
	{ 16, 0x1D},
	{ 17, 0x06},
	{ 18, 0xC0},
	{ 19, 0x0D},
	{ 20, 0x1D},
	{ 21, 0x07},
	{ 22, 0x00},
	{ 23, 0x0F},
	{ 24, 0x4D},
	{ 25, 0x06},
	{ 26, 0x60},
	{ 27, 0x0B},
	{ 28, 0x1D},
	{ 29, 0x07},
	{ 30, 0x40},
	{ 31, 0x10},
	{ 32, 0x00},
	{ 33, 0x00},
	{ 34, 0x00},
	{ 35, 0x00},
	{ 36, 0x25},
	{ 37, 0x06},
	{ 38, 0xE0},
	{ 39, 0x02},
	{ 40, 0x19},
	{ 41, 0x07},
	{ 42, 0xA0},
	{ 43, 0x0F},
	{ 44, 0x1D},
	{ 45, 0x07},
	{ 46, 0xE0},
	{ 47, 0x10},
	{ 48, 0x1D},
	{ 49, 0x08},
	{ 50, 0x20},
	{ 51, 0x12},
	{ 52, 0x4D},
	{ 53, 0x07},
	{ 54, 0x80},
	{ 55, 0x0E},
	{ 56, 0x1D},
	{ 57, 0x08},
	{ 58, 0x60},
	{ 59, 0x13},
	{ 60, 0x00},
	{ 61, 0x00},
	{ 62, 0x00},
	{ 63, 0x00},
	{ 64, 0x25},
	{ 65, 0x08},
	{ 66, 0x00},
	{ 67, 0x02},
	{ 68, 0x00},
	{ 69, 0x00},
	{ 70, 0x00},
	{ 71, 0x00},
	{ 72, 0x00},
	{ 73, 0x00},
	{ 74, 0x00},
	{ 75, 0x00},
	{ 76, 0x00},
	{ 77, 0x00},
	{ 78, 0x00},
	{ 79, 0x00},
	{ 80, 0x10},
	{ 81, 0x00},
	{ 82, 0x00},
	{ 83, 0x11},
	{ 84, 0x5C},
	{ 85, 0x60},
	{ 86, 0x00},
	{ 87, 0x01},
	{ 88, 0x19},
	{ 89, 0x03},
	{ 90, 0x20},
	{ 91, 0x15},
	{ 92, 0x1D},
	{ 93, 0x03},
	{ 94, 0x60},
	{ 95, 0x16},
	{ 96, 0x1D},
	{ 97, 0x03},
	{ 98, 0xA0},
	{ 99, 0x18},
	{100, 0x4D},
	{101, 0x03},
	{102, 0x00},
	{103, 0x14},
	{104, 0x1D},
	{105, 0x03},
	{106, 0xE0},
	{107, 0x19},
	{108, 0x00},
	{109, 0x00},
	{110, 0x00},
	{111, 0x00},
	{112, 0x25},
	{113, 0x03},
	{114, 0x80},
	{115, 0x02},
	{116, 0x19},
	{117, 0x04},
	{118, 0x40},
	{119, 0x18},
	{120, 0x1D},
	{121, 0x04},
	{122, 0x80},
	{123, 0x19},
	{124, 0x1D},
	{125, 0x04},
	{126, 0xC0},
	{127, 0x1B},
	{  0, 0x07},
	{  8, 0x4D},
	{  9, 0x04},
	{ 10, 0x20},
	{ 11, 0x17},
	{ 12, 0x1D},
	{ 13, 0x05},
	{ 14, 0x00},
	{ 15, 0x1C},
	{ 16, 0x00},
	{ 17, 0x00},
	{ 18, 0x00},
	{ 19, 0x00},
	{ 20, 0x25},
	{ 21, 0x04},
	{ 22, 0xA0},
	{ 23, 0x02},
	{ 24, 0x19},
	{ 25, 0x05},
	{ 26, 0x60},
	{ 27, 0x1B},
	{ 28, 0x1D},
	{ 29, 0x05},
	{ 30, 0xA0},
	{ 31, 0x1C},
	{ 32, 0x1D},
	{ 33, 0x05},
	{ 34, 0xE0},
	{ 35, 0x1E},
	{ 36, 0x4D},
	{ 37, 0x05},
	{ 38, 0x40},
	{ 39, 0x1A},
	{ 40, 0x1D},
	{ 41, 0x06},
	{ 42, 0x20},
	{ 43, 0x1F},
	{ 44, 0x00},
	{ 45, 0x00},
	{ 46, 0x00},
	{ 47, 0x00},
	{ 48, 0x25},
	{ 49, 0x05},
	{ 50, 0xC0},
	{ 51, 0x02},
	{ 52, 0x19},
	{ 53, 0x06},
	{ 54, 0x80},
	{ 55, 0x1E},
	{ 56, 0x1D},
	{ 57, 0x06},
	{ 58, 0xC0},
	{ 59, 0x1F},
	{ 60, 0x1D},
	{ 61, 0x07},
	{ 62, 0x00},
	{ 63, 0x21},
	{ 64, 0x4D},
	{ 65, 0x06},
	{ 66, 0x60},
	{ 67, 0x1D},
	{ 68, 0x1D},
	{ 69, 0x07},
	{ 70, 0x40},
	{ 71, 0x22},
	{ 72, 0x00},
	{ 73, 0x00},
	{ 74, 0x00},
	{ 75, 0x00},
	{ 76, 0x25},
	{ 77, 0x06},
	{ 78, 0xE0},
	{ 79, 0x02},
	{ 80, 0x19},
	{ 81, 0x07},
	{ 82, 0xA0},
	{ 83, 0x21},
	{ 84, 0x1D},
	{ 85, 0x07},
	{ 86, 0xE0},
	{ 87, 0x22},
	{ 88, 0x1D},
	{ 89, 0x08},
	{ 90, 0x20},
	{ 91, 0x24},
	{ 92, 0x4D},
	{ 93, 0x07},
	{ 94, 0x80},
	{ 95, 0x20},
	{ 96, 0x1D},
	{ 97, 0x08},
	{ 98, 0x60},
	{ 99, 0x25},
	{100, 0x00},
	{101, 0x00},
	{102, 0x00},
	{103, 0x00},
	{104, 0x25},
	{105, 0x08},
	{106, 0x00},
	{107, 0x02},
	{108, 0x00},
	{109, 0x00},
	{110, 0x00},
	{111, 0x00},
	{112, 0x00},
	{113, 0x00},
	{114, 0x00},
	{115, 0x00},
	{116, 0x00},
	{117, 0x00},
	{118, 0x00},
	{119, 0x00},
	{120, 0x10},
	{121, 0x00},
	{122, 0x00},
	{123, 0x23},
	{124, 0x58},
	{125, 0x60},
	{126, 0x00},
	{127, 0x05},
	{  0, 0x08},
	{  8, 0x18},
	{  9, 0x01},
	{ 10, 0x80},
	{ 11, 0x11},
	{ 12, 0x18},
	{ 13, 0x01},
	{ 14, 0x80},
	{ 15, 0x23},
	{ 16, 0x18},
	{ 17, 0x01},
	{ 18, 0x80},
	{ 19, 0x00},
	{ 20, 0x44},
	{ 21, 0x00},
	{ 22, 0xC0},
	{ 23, 0x05},
	{ 24, 0x10},
	{ 25, 0x00},
	{ 26, 0x20},
	{ 27, 0x2C},
	{ 28, 0x10},
	{ 29, 0x00},
	{ 30, 0x20},
	{ 31, 0x2D},
	{ 32, 0x00},
	{ 33, 0x00},
	{ 34, 0x00},
	{ 35, 0x00},
	{ 36, 0x00},
	{ 37, 0x00},
	{ 38, 0x00},
	{ 39, 0x00},
	{ 40, 0x44},
	{ 41, 0x00},
	{ 42, 0x00},
	{ 43, 0x05},
	{ 44, 0x18},
	{ 45, 0x01},
	{ 46, 0x80},
	{ 47, 0x01},
	{ 48, 0x00},
	{ 49, 0x00},
	{ 50, 0x00},
	{ 51, 0x00},
	{ 52, 0x10},
	{ 53, 0x00},
	{ 54, 0x20},
	{ 55, 0x2C},
	{ 56, 0x00},
	{ 57, 0x00},
	{ 58, 0x00},
	{ 59, 0x00},
	{ 60, 0x10},
	{ 61, 0x00},
	{ 62, 0x20},
	{ 63, 0x2D},
	{ 64, 0x58},
	{ 65, 0x60},
	{ 66, 0x00},
	{ 67, 0x06},
	{ 68, 0x40},
	{ 69, 0x02},
	{ 70, 0x40},
	{ 71, 0x35},
	{ 72, 0x1C},
	{ 73, 0x02},
	{ 74, 0x40},
	{ 75, 0x33},
	{ 76, 0x00},
	{ 77, 0x00},
	{ 78, 0x00},
	{ 79, 0x00},
	{ 80, 0x10},
	{ 81, 0x00},
	{ 82, 0x20},
	{ 83, 0x34},
	{ 84, 0x44},
	{ 85, 0x00},
	{ 86, 0x40},
	{ 87, 0x06},
	{ 88, 0x10},
	{ 89, 0x12},
	{ 90, 0xE0},
	{ 91, 0x31},
	{ 92, 0x00},
	{ 93, 0x00},
	{ 94, 0x00},
	{ 95, 0x00},
	{ 96, 0x00},
	{ 97, 0x00},
	{ 98, 0x00},
	{ 99, 0x00},
	{100, 0x18},
	{101, 0x01},
	{102, 0x80},
	{103, 0x33},
	{104, 0x00},
	{105, 0x00},
	{106, 0x00},
	{107, 0x00},
	{108, 0x44},
	{109, 0x00},
	{110, 0x00},
	{111, 0x19},
	{112, 0x18},
	{113, 0x01},
	{114, 0x80},
	{115, 0x31},
	{116, 0x59},
	{117, 0x00},
	{118, 0x00},
	{119, 0x0E},
	{120, 0x1C},
	{121, 0x01},
	{122, 0x80},
	{123, 0x33},
	{124, 0x40},
	{125, 0x02},
	{126, 0x40},
	{127, 0x34},
	{  0, 0x09},
	{  8, 0x44},
	{  9, 0x00},
	{ 10, 0xC0},
	{ 11, 0x0A},
	{ 12, 0x44},
	{ 13, 0x00},
	{ 14, 0x40},
	{ 15, 0x13},
	{ 16, 0x10},
	{ 17, 0x00},
	{ 18, 0x20},
	{ 19, 0x32},
	{ 20, 0x44},
	{ 21, 0x00},
	{ 22, 0x80},
	{ 23, 0x13},
	{ 24, 0x18},
	{ 25, 0x01},
	{ 26, 0x80},
	{ 27, 0x34},
	{ 28, 0x00},
	{ 29, 0x00},
	{ 30, 0x00},
	{ 31, 0x00},
	{ 32, 0x00},
	{ 33, 0x00},
	{ 34, 0x00},
	{ 35, 0x00},
	{ 36, 0x58},
	{ 37, 0x60},
	{ 38, 0x00},
	{ 39, 0x0E},
	{ 40, 0x10},
	{ 41, 0x00},
	{ 42, 0x20},
	{ 43, 0x32},
	{ 44, 0x20},
	{ 45, 0x02},
	{ 46, 0x00},
	{ 47, 0x02},
	{ 48, 0x44},
	{ 49, 0x00},
	{ 50, 0x00},
	{ 51, 0x13},
	{ 52, 0x00},
	{ 53, 0x00},
	{ 54, 0x00},
	{ 55, 0x00},
	{ 56, 0x10},
	{ 57, 0x00},
	{ 58, 0x20},
	{ 59, 0x32},
	{ 60, 0x44},
	{ 61, 0x00},
	{ 62, 0x60},
	{ 63, 0x09},
	{ 64, 0x18},
	{ 65, 0x01},
	{ 66, 0x80},
	{ 67, 0x34},
	{ 68, 0x00},
	{ 69, 0x00},
	{ 70, 0x00},
	{ 71, 0x00},
	{ 72, 0x00},
	{ 73, 0x00},
	{ 74, 0x00},
	{ 75, 0x00},
	{ 76, 0x58},
	{ 77, 0x60},
	{ 78, 0x00},
	{ 79, 0x0E},
	{ 80, 0x10},
	{ 81, 0x00},
	{ 82, 0x20},
	{ 83, 0x32},
	{ 84, 0x20},
	{ 85, 0x02},
	{ 86, 0x00},
	{ 87, 0x02},
	{ 88, 0x44},
	{ 89, 0x00},
	{ 90, 0x00},
	{ 91, 0x09},
	{ 92, 0x00},
	{ 93, 0x00},
	{ 94, 0x00},
	{ 95, 0x00},
	{ 96, 0x10},
	{ 97, 0x00},
	{ 98, 0x20},
	{ 99, 0x32},
	{100, 0x20},
	{101, 0x02},
	{102, 0x00},
	{103, 0x02},
	{104, 0x00},
	{105, 0x00},
	{106, 0x00},
	{107, 0x00},
	{108, 0x00},
	{109, 0x00},
	{110, 0x00},
	{111, 0x00},
	{112, 0x18},
	{113, 0x01},
	{114, 0x80},
	{115, 0x31},
	{116, 0x00},
	{117, 0x00},
	{118, 0x00},
	{119, 0x00},
	{120, 0x00},
	{121, 0x00},
	{122, 0x00},
	{123, 0x00},
	{124, 0x00},
	{125, 0x00},
	{126, 0x00},
	{127, 0x00},
	{  0, 0x0A},
	{  8, 0x10},
	{  9, 0x00},
	{ 10, 0x20},
	{ 11, 0x30},
	{ 12, 0x18},
	{ 13, 0x02},
	{ 14, 0x00},
	{ 15, 0x2C},
	{ 16, 0x18},
	{ 17, 0x02},
	{ 18, 0x00},
	{ 19, 0x2D},
	{ 20, 0x58},
	{ 21, 0x60},
	{ 22, 0x00},
	{ 23, 0x10},
	{ 24, 0x00},
	{ 25, 0x00},
	{ 26, 0x00},
	{ 27, 0x00},
	{ 28, 0x10},
	{ 29, 0x00},
	{ 30, 0x20},
	{ 31, 0x2E},
	{ 32, 0x10},
	{ 33, 0x00},
	{ 34, 0x20},
	{ 35, 0x2F},
	{ 36, 0x20},
	{ 37, 0x02},
	{ 38, 0x20},
	{ 39, 0x9F},
	{ 40, 0x18},
	{ 41, 0x01},
	{ 42, 0x80},
	{ 43, 0x2E},
	{ 44, 0x18},
	{ 45, 0x01},
	{ 46, 0x80},
	{ 47, 0x2F},
	{ 48, 0x18},
	{ 49, 0x00},
	{ 50, 0x60},
	{ 51, 0x39},
	{ 52, 0x1C},
	{ 53, 0x00},
	{ 54, 0x80},
	{ 55, 0x3B},
	{ 56, 0x10},
	{ 57, 0x00},
	{ 58, 0x20},
	{ 59, 0x38},
	{ 60, 0x10},
	{ 61, 0x00},
	{ 62, 0x20},
	{ 63, 0x76},
	{ 64, 0x1C},
	{ 65, 0x00},
	{ 66, 0x40},
	{ 67, 0x38},
	{ 68, 0x18},
	{ 69, 0x00},
	{ 70, 0x60},
	{ 71, 0x77},
	{ 72, 0x1C},
	{ 73, 0x00},
	{ 74, 0x80},
	{ 75, 0x7B},
	{ 76, 0x1C},
	{ 77, 0x00},
	{ 78, 0x40},
	{ 79, 0x76},
	{ 80, 0x10},
	{ 81, 0x30},
	{ 82, 0x00},
	{ 83, 0x3A},
	{ 84, 0x00},
	{ 85, 0x00},
	{ 86, 0x00},
	{ 87, 0x00},
	{ 88, 0x00},
	{ 89, 0x00},
	{ 90, 0x00},
	{ 91, 0x00},
	{ 92, 0x10},
	{ 93, 0x30},
	{ 94, 0x00},
	{ 95, 0x7A},
	{ 96, 0x18},
	{ 97, 0x02},
	{ 98, 0x60},
	{ 99, 0x5F},
	{100, 0x1C},
	{101, 0x02},
	{102, 0x80},
	{103, 0x3C},
	{104, 0x1C},
	{105, 0x02},
	{106, 0x60},
	{107, 0x3A},
	{108, 0x1C},
	{109, 0x02},
	{110, 0x80},
	{111, 0x5D},
	{112, 0x1C},
	{113, 0x02},
	{114, 0xA0},
	{115, 0x3E},
	{116, 0x1C},
	{117, 0x02},
	{118, 0xA0},
	{119, 0x5B},
	{120, 0x1C},
	{121, 0x02},
	{122, 0xC0},
	{123, 0x40},
	{124, 0x1C},
	{125, 0x02},
	{126, 0xC0},
	{127, 0x59},
	{  0, 0x0B},
	{  8, 0x1C},
	{  9, 0x02},
	{ 10, 0xE0},
	{ 11, 0x46},
	{ 12, 0x1C},
	{ 13, 0x02},
	{ 14, 0xE0},
	{ 15, 0x53},
	{ 16, 0x1C},
	{ 17, 0x03},
	{ 18, 0x00},
	{ 19, 0x42},
	{ 20, 0x1C},
	{ 21, 0x03},
	{ 22, 0x00},
	{ 23, 0x57},
	{ 24, 0x1C},
	{ 25, 0x03},
	{ 26, 0x20},
	{ 27, 0x44},
	{ 28, 0x1C},
	{ 29, 0x03},
	{ 30, 0x20},
	{ 31, 0x55},
	{ 32, 0x1C},
	{ 33, 0x03},
	{ 34, 0x40},
	{ 35, 0x48},
	{ 36, 0x1C},
	{ 37, 0x03},
	{ 38, 0x40},
	{ 39, 0x51},
	{ 40, 0x1C},
	{ 41, 0x03},
	{ 42, 0x60},
	{ 43, 0x4A},
	{ 44, 0x1C},
	{ 45, 0x03},
	{ 46, 0x60},
	{ 47, 0x4F},
	{ 48, 0x1C},
	{ 49, 0x03},
	{ 50, 0x80},
	{ 51, 0x3B},
	{ 52, 0x1C},
	{ 53, 0x03},
	{ 54, 0x80},
	{ 55, 0x5E},
	{ 56, 0x1C},
	{ 57, 0x03},
	{ 58, 0xA0},
	{ 59, 0x43},
	{ 60, 0x1C},
	{ 61, 0x03},
	{ 62, 0xA0},
	{ 63, 0x56},
	{ 64, 0x1C},
	{ 65, 0x03},
	{ 66, 0xC0},
	{ 67, 0x3F},
	{ 68, 0x1C},
	{ 69, 0x03},
	{ 70, 0xC0},
	{ 71, 0x5A},
	{ 72, 0x1C},
	{ 73, 0x03},
	{ 74, 0xE0},
	{ 75, 0x47},
	{ 76, 0x1C},
	{ 77, 0x03},
	{ 78, 0xE0},
	{ 79, 0x52},
	{ 80, 0x1C},
	{ 81, 0x04},
	{ 82, 0x00},
	{ 83, 0x41},
	{ 84, 0x1C},
	{ 85, 0x04},
	{ 86, 0x00},
	{ 87, 0x58},
	{ 88, 0x1C},
	{ 89, 0x04},
	{ 90, 0x20},
	{ 91, 0x3D},
	{ 92, 0x1C},
	{ 93, 0x04},
	{ 94, 0x20},
	{ 95, 0x5C},
	{ 96, 0x1C},
	{ 97, 0x04},
	{ 98, 0x40},
	{ 99, 0x45},
	{100, 0x1C},
	{101, 0x04},
	{102, 0x40},
	{103, 0x54},
	{104, 0x1C},
	{105, 0x04},
	{106, 0x60},
	{107, 0x49},
	{108, 0x1C},
	{109, 0x04},
	{110, 0x60},
	{111, 0x50},
	{112, 0x1C},
	{113, 0x04},
	{114, 0x80},
	{115, 0x4B},
	{116, 0x1C},
	{117, 0x04},
	{118, 0x80},
	{119, 0x4E},
	{120, 0x1C},
	{121, 0x04},
	{122, 0xA0},
	{123, 0x4C},
	{124, 0x1C},
	{125, 0x04},
	{126, 0xA0},
	{127, 0x4D},
	{  0, 0x0C},
	{  8, 0x00},
	{  9, 0x00},
	{ 10, 0x00},
	{ 11, 0x00},
	{ 12, 0x00},
	{ 13, 0x00},
	{ 14, 0x00},
	{ 15, 0x00},
	{ 16, 0x00},
	{ 17, 0x00},
	{ 18, 0x00},
	{ 19, 0x00},
	{ 20, 0x10},
	{ 21, 0x00},
	{ 22, 0x00},
	{ 23, 0x64},
	{ 24, 0x18},
	{ 25, 0x02},
	{ 26, 0x60},
	{ 27, 0x9F},
	{ 28, 0x1C},
	{ 29, 0x02},
	{ 30, 0x80},
	{ 31, 0x7C},
	{ 32, 0x1C},
	{ 33, 0x02},
	{ 34, 0x60},
	{ 35, 0x7A},
	{ 36, 0x1C},
	{ 37, 0x02},
	{ 38, 0x80},
	{ 39, 0x9D},
	{ 40, 0x1C},
	{ 41, 0x02},
	{ 42, 0xA0},
	{ 43, 0x7E},
	{ 44, 0x1C},
	{ 45, 0x02},
	{ 46, 0xA0},
	{ 47, 0x9B},
	{ 48, 0x1C},
	{ 49, 0x02},
	{ 50, 0xC0},
	{ 51, 0x80},
	{ 52, 0x1C},
	{ 53, 0x02},
	{ 54, 0xC0},
	{ 55, 0x99},
	{ 56, 0x1C},
	{ 57, 0x02},
	{ 58, 0xE0},
	{ 59, 0x86},
	{ 60, 0x1C},
	{ 61, 0x02},
	{ 62, 0xE0},
	{ 63, 0x93},
	{ 64, 0x1C},
	{ 65, 0x03},
	{ 66, 0x00},
	{ 67, 0x82},
	{ 68, 0x1C},
	{ 69, 0x03},
	{ 70, 0x00},
	{ 71, 0x97},
	{ 72, 0x1C},
	{ 73, 0x03},
	{ 74, 0x20},
	{ 75, 0x84},
	{ 76, 0x1C},
	{ 77, 0x03},
	{ 78, 0x20},
	{ 79, 0x95},
	{ 80, 0x1C},
	{ 81, 0x03},
	{ 82, 0x40},
	{ 83, 0x88},
	{ 84, 0x1C},
	{ 85, 0x03},
	{ 86, 0x40},
	{ 87, 0x91},
	{ 88, 0x1C},
	{ 89, 0x03},
	{ 90, 0x60},
	{ 91, 0x8A},
	{ 92, 0x1C},
	{ 93, 0x03},
	{ 94, 0x60},
	{ 95, 0x8F},
	{ 96, 0x1C},
	{ 97, 0x03},
	{ 98, 0x80},
	{ 99, 0x7B},
	{100, 0x1C},
	{101, 0x03},
	{102, 0x80},
	{103, 0x9E},
	{104, 0x1C},
	{105, 0x03},
	{106, 0xA0},
	{107, 0x83},
	{108, 0x1C},
	{109, 0x03},
	{110, 0xA0},
	{111, 0x96},
	{112, 0x1C},
	{113, 0x03},
	{114, 0xC0},
	{115, 0x7F},
	{116, 0x1C},
	{117, 0x03},
	{118, 0xC0},
	{119, 0x9A},
	{120, 0x1C},
	{121, 0x03},
	{122, 0xE0},
	{123, 0x87},
	{124, 0x1C},
	{125, 0x03},
	{126, 0xE0},
	{127, 0x92},
	{  0, 0x0D},
	{  8, 0x1C},
	{  9, 0x04},
	{ 10, 0x00},
	{ 11, 0x81},
	{ 12, 0x1C},
	{ 13, 0x04},
	{ 14, 0x00},
	{ 15, 0x98},
	{ 16, 0x1C},
	{ 17, 0x04},
	{ 18, 0x20},
	{ 19, 0x7D},
	{ 20, 0x1C},
	{ 21, 0x04},
	{ 22, 0x20},
	{ 23, 0x9C},
	{ 24, 0x1C},
	{ 25, 0x04},
	{ 26, 0x40},
	{ 27, 0x85},
	{ 28, 0x1C},
	{ 29, 0x04},
	{ 30, 0x40},
	{ 31, 0x94},
	{ 32, 0x1C},
	{ 33, 0x04},
	{ 34, 0x60},
	{ 35, 0x89},
	{ 36, 0x1C},
	{ 37, 0x04},
	{ 38, 0x60},
	{ 39, 0x90},
	{ 40, 0x1C},
	{ 41, 0x04},
	{ 42, 0x80},
	{ 43, 0x8B},
	{ 44, 0x1C},
	{ 45, 0x04},
	{ 46, 0x80},
	{ 47, 0x8E},
	{ 48, 0x1C},
	{ 49, 0x04},
	{ 50, 0xA0},
	{ 51, 0x8C},
	{ 52, 0x1C},
	{ 53, 0x04},
	{ 54, 0xA0},
	{ 55, 0x8D},
	{ 56, 0x00},
	{ 57, 0x00},
	{ 58, 0x00},
	{ 59, 0x00},
	{ 60, 0x00},
	{ 61, 0x00},
	{ 62, 0x00},
	{ 63, 0x00},
	{ 64, 0x00},
	{ 65, 0x00},
	{ 66, 0x00},
	{ 67, 0x00},
	{ 68, 0x10},
	{ 69, 0x00},
	{ 70, 0x00},
	{ 71, 0xA4},
	{ 72, 0x18},
	{ 73, 0x04},
	{ 74, 0xE0},
	{ 75, 0xA3},
	{ 76, 0x1C},
	{ 77, 0x05},
	{ 78, 0x00},
	{ 79, 0xA5},
	{ 80, 0x1C},
	{ 81, 0x05},
	{ 82, 0x00},
	{ 83, 0xA2},
	{ 84, 0x1C},
	{ 85, 0x04},
	{ 86, 0xE0},
	{ 87, 0xA4},
	{ 88, 0x1C},
	{ 89, 0x05},
	{ 90, 0x20},
	{ 91, 0xA1},
	{ 92, 0x1C},
	{ 93, 0x05},
	{ 94, 0x20},
	{ 95, 0xA6},
	{ 96, 0x1C},
	{ 97, 0x05},
	{ 98, 0x40},
	{ 99, 0xA0},
	{100, 0x1C},
	{101, 0x05},
	{102, 0x40},
	{103, 0xA7},
	{104, 0x18},
	{105, 0x05},
	{106, 0xA0},
	{107, 0xA8},
	{108, 0x1C},
	{109, 0x05},
	{110, 0xA0},
	{111, 0xAA},
	{112, 0x1C},
	{113, 0x05},
	{114, 0x80},
	{115, 0xAD},
	{116, 0x4C},
	{117, 0x05},
	{118, 0x80},
	{119, 0xAB},
	{120, 0x00},
	{121, 0x00},
	{122, 0x00},
	{123, 0x00},
	{124, 0x5C},
	{125, 0x90},
	{126, 0x60},
	{127, 0x03},
	{  0, 0x0E},
	{  8, 0x18},
	{  9, 0x04},
	{ 10, 0xE0},
	{ 11, 0x63},
	{ 12, 0x1C},
	{ 13, 0x04},
	{ 14, 0xE0},
	{ 15, 0x64},
	{ 16, 0x1C},
	{ 17, 0x05},
	{ 18, 0x00},
	{ 19, 0x65},
	{ 20, 0x10},
	{ 21, 0x00},
	{ 22, 0x40},
	{ 23, 0xB4},
	{ 24, 0x1C},
	{ 25, 0x05},
	{ 26, 0x00},
	{ 27, 0x62},
	{ 28, 0x1C},
	{ 29, 0x05},
	{ 30, 0x20},
	{ 31, 0x61},
	{ 32, 0x1C},
	{ 33, 0x05},
	{ 34, 0x20},
	{ 35, 0x66},
	{ 36, 0x1C},
	{ 37, 0x05},
	{ 38, 0x40},
	{ 39, 0x60},
	{ 40, 0x1C},
	{ 41, 0x05},
	{ 42, 0x40},
	{ 43, 0x67},
	{ 44, 0x18},
	{ 45, 0x05},
	{ 46, 0xA0},
	{ 47, 0x68},
	{ 48, 0x1C},
	{ 49, 0x05},
	{ 50, 0xA0},
	{ 51, 0x6A},
	{ 52, 0x1C},
	{ 53, 0x05},
	{ 54, 0x80},
	{ 55, 0x6D},
	{ 56, 0x4C},
	{ 57, 0x05},
	{ 58, 0x80},
	{ 59, 0x6B},
	{ 60, 0x00},
	{ 61, 0x00},
	{ 62, 0x00},
	{ 63, 0x00},
	{ 64, 0x5C},
	{ 65, 0x90},
	{ 66, 0x40},
	{ 67, 0x03},
	{ 68, 0x00},
	{ 69, 0x00},
	{ 70, 0x00},
	{ 71, 0x00},
	{ 72, 0x00},
	{ 73, 0x00},
	{ 74, 0x00},
	{ 75, 0x00},
	{ 76, 0x00},
	{ 77, 0x00},
	{ 78, 0x00},
	{ 79, 0x00},
	{ 80, 0x10},
	{ 81, 0x00},
	{ 82, 0x40},
	{ 83, 0x74},
	{ 84, 0x18},
	{ 85, 0x05},
	{ 86, 0xC0},
	{ 87, 0xAB},
	{ 88, 0x1C},
	{ 89, 0x05},
	{ 90, 0xC0},
	{ 91, 0xAA},
	{ 92, 0x1C},
	{ 93, 0x05},
	{ 94, 0xE0},
	{ 95, 0xA8},
	{ 96, 0x00},
	{ 97, 0x00},
	{ 98, 0x00},
	{ 99, 0x00},
	{100, 0x5C},
	{101, 0x90},
	{102, 0x60},
	{103, 0x03},
	{104, 0x18},
	{105, 0x05},
	{106, 0xC0},
	{107, 0x6B},
	{108, 0x1C},
	{109, 0x05},
	{110, 0xC0},
	{111, 0x6A},
	{112, 0x1C},
	{113, 0x05},
	{114, 0xE0},
	{115, 0x68},
	{116, 0x10},
	{117, 0x00},
	{118, 0x40},
	{119, 0xB3},
	{120, 0x18},
	{121, 0x05},
	{122, 0x60},
	{123, 0xA1},
	{124, 0x5C},
	{125, 0x90},
	{126, 0x40},
	{127, 0x03},
	{  0, 0x0F},
	{  8, 0x18},
	{  9, 0x05},
	{ 10, 0x80},
	{ 11, 0xAA},
	{ 12, 0x1C},
	{ 13, 0x05},
	{ 14, 0xA0},
	{ 15, 0xAB},
	{ 16, 0x4C},
	{ 17, 0x05},
	{ 18, 0x80},
	{ 19, 0xAC},
	{ 20, 0x10},
	{ 21, 0x00},
	{ 22, 0x40},
	{ 23, 0x73},
	{ 24, 0x1C},
	{ 25, 0x05},
	{ 26, 0xA0},
	{ 27, 0xA8},
	{ 28, 0x18},
	{ 29, 0x05},
	{ 30, 0x60},
	{ 31, 0x61},
	{ 32, 0x5C},
	{ 33, 0x90},
	{ 34, 0x60},
	{ 35, 0x03},
	{ 36, 0x18},
	{ 37, 0x05},
	{ 38, 0x80},
	{ 39, 0x6A},
	{ 40, 0x1C},
	{ 41, 0x05},
	{ 42, 0xA0},
	{ 43, 0x6B},
	{ 44, 0x4C},
	{ 45, 0x05},
	{ 46, 0x80},
	{ 47, 0x6C},
	{ 48, 0x10},
	{ 49, 0x00},
	{ 50, 0x40},
	{ 51, 0xB2},
	{ 52, 0x1C},
	{ 53, 0x05},
	{ 54, 0xA0},
	{ 55, 0x68},
	{ 56, 0x00},
	{ 57, 0x00},
	{ 58, 0x00},
	{ 59, 0x00},
	{ 60, 0x5C},
	{ 61, 0x90},
	{ 62, 0x40},
	{ 63, 0x03},
	{ 64, 0x18},
	{ 65, 0x05},
	{ 66, 0xC0},
	{ 67, 0xAC},
	{ 68, 0x1C},
	{ 69, 0x05},
	{ 70, 0xC0},
	{ 71, 0xA8},
	{ 72, 0x1C},
	{ 73, 0x05},
	{ 74, 0xE0},
	{ 75, 0xAB},
	{ 76, 0x10},
	{ 77, 0x00},
	{ 78, 0x40},
	{ 79, 0x72},
	{ 80, 0x5C},
	{ 81, 0x90},
	{ 82, 0x60},
	{ 83, 0x03},
	{ 84, 0x00},
	{ 85, 0x00},
	{ 86, 0x00},
	{ 87, 0x00},
	{ 88, 0x00},
	{ 89, 0x00},
	{ 90, 0x00},
	{ 91, 0x00},
	{ 92, 0x00},
	{ 93, 0x00},
	{ 94, 0x00},
	{ 95, 0x00},
	{ 96, 0x10},
	{ 97, 0x00},
	{ 98, 0x40},
	{ 99, 0xB1},
	{100, 0x18},
	{101, 0x05},
	{102, 0xC0},
	{103, 0x6C},
	{104, 0x1C},
	{105, 0x05},
	{106, 0xC0},
	{107, 0x68},
	{108, 0x1C},
	{109, 0x05},
	{110, 0xE0},
	{111, 0x6B},
	{112, 0x18},
	{113, 0x04},
	{114, 0xC0},
	{115, 0x8C},
	{116, 0x5C},
	{117, 0x90},
	{118, 0x40},
	{119, 0x03},
	{120, 0x18},
	{121, 0x04},
	{122, 0xE0},
	{123, 0xA7},
	{124, 0x1C},
	{125, 0x05},
	{126, 0x00},
	{127, 0xA0},
	{  0, 0x10},
	{  8, 0x4C},
	{  9, 0x04},
	{ 10, 0xE0},
	{ 11, 0x9F},
	{ 12, 0x10},
	{ 13, 0x00},
	{ 14, 0x40},
	{ 15, 0x71},
	{ 16, 0x1C},
	{ 17, 0x05},
	{ 18, 0x00},
	{ 19, 0xA6},
	{ 20, 0x1C},
	{ 21, 0x05},
	{ 22, 0x20},
	{ 23, 0xA5},
	{ 24, 0x1C},
	{ 25, 0x05},
	{ 26, 0x20},
	{ 27, 0xA1},
	{ 28, 0x1C},
	{ 29, 0x05},
	{ 30, 0x40},
	{ 31, 0xA4},
	{ 32, 0x1C},
	{ 33, 0x05},
	{ 34, 0x40},
	{ 35, 0xA2},
	{ 36, 0x18},
	{ 37, 0x05},
	{ 38, 0xA0},
	{ 39, 0xAC},
	{ 40, 0x1C},
	{ 41, 0x05},
	{ 42, 0xA0},
	{ 43, 0xAB},
	{ 44, 0x1C},
	{ 45, 0x05},
	{ 46, 0x80},
	{ 47, 0xA8},
	{ 48, 0x4C},
	{ 49, 0x05},
	{ 50, 0x80},
	{ 51, 0xA9},
	{ 52, 0x18},
	{ 53, 0x04},
	{ 54, 0xC0},
	{ 55, 0x4C},
	{ 56, 0x5C},
	{ 57, 0x90},
	{ 58, 0x60},
	{ 59, 0x03},
	{ 60, 0x18},
	{ 61, 0x04},
	{ 62, 0xE0},
	{ 63, 0x67},
	{ 64, 0x1C},
	{ 65, 0x05},
	{ 66, 0x00},
	{ 67, 0x60},
	{ 68, 0x4C},
	{ 69, 0x04},
	{ 70, 0xE0},
	{ 71, 0x5F},
	{ 72, 0x10},
	{ 73, 0x00},
	{ 74, 0x40},
	{ 75, 0xB0},
	{ 76, 0x1C},
	{ 77, 0x05},
	{ 78, 0x00},
	{ 79, 0x66},
	{ 80, 0x1C},
	{ 81, 0x05},
	{ 82, 0x20},
	{ 83, 0x65},
	{ 84, 0x1C},
	{ 85, 0x05},
	{ 86, 0x20},
	{ 87, 0x61},
	{ 88, 0x1C},
	{ 89, 0x05},
	{ 90, 0x40},
	{ 91, 0x64},
	{ 92, 0x1C},
	{ 93, 0x05},
	{ 94, 0x40},
	{ 95, 0x62},
	{ 96, 0x18},
	{ 97, 0x05},
	{ 98, 0xA0},
	{ 99, 0x6C},
	{100, 0x1C},
	{101, 0x05},
	{102, 0xA0},
	{103, 0x6B},
	{104, 0x1C},
	{105, 0x05},
	{106, 0x80},
	{107, 0x68},
	{108, 0x4C},
	{109, 0x05},
	{110, 0x80},
	{111, 0x69},
	{112, 0x00},
	{113, 0x00},
	{114, 0x00},
	{115, 0x00},
	{116, 0x5C},
	{117, 0x90},
	{118, 0x40},
	{119, 0x03},
	{120, 0x00},
	{121, 0x00},
	{122, 0x00},
	{123, 0x00},
	{124, 0x00},
	{125, 0x00},
	{126, 0x00},
	{127, 0x00},
	{  0, 0x11},
	{  8, 0x00},
	{  9, 0x00},
	{ 10, 0x00},
	{ 11, 0x00},
	{ 12, 0x10},
	{ 13, 0x00},
	{ 14, 0x40},
	{ 15, 0x6F},
	{ 16, 0x18},
	{ 17, 0x05},
	{ 18, 0xC0},
	{ 19, 0xA9},
	{ 20, 0x1C},
	{ 21, 0x05},
	{ 22, 0xC0},
	{ 23, 0xAB},
	{ 24, 0x1C},
	{ 25, 0x05},
	{ 26, 0xE0},
	{ 27, 0xAC},
	{ 28, 0x10},
	{ 29, 0x00},
	{ 30, 0x40},
	{ 31, 0x70},
	{ 32, 0x00},
	{ 33, 0x00},
	{ 34, 0x00},
	{ 35, 0x00},
	{ 36, 0x5C},
	{ 37, 0x90},
	{ 38, 0x60},
	{ 39, 0x03},
	{ 40, 0x18},
	{ 41, 0x05},
	{ 42, 0xC0},
	{ 43, 0x69},
	{ 44, 0x1C},
	{ 45, 0x05},
	{ 46, 0xC0},
	{ 47, 0x6B},
	{ 48, 0x1C},
	{ 49, 0x05},
	{ 50, 0xE0},
	{ 51, 0x6C},
	{ 52, 0x10},
	{ 53, 0x00},
	{ 54, 0x40},
	{ 55, 0xAF},
	{ 56, 0x18},
	{ 57, 0x05},
	{ 58, 0x60},
	{ 59, 0xA5},
	{ 60, 0x5C},
	{ 61, 0x90},
	{ 62, 0x40},
	{ 63, 0x03},
	{ 64, 0x18},
	{ 65, 0x05},
	{ 66, 0x80},
	{ 67, 0xAB},
	{ 68, 0x1C},
	{ 69, 0x05},
	{ 70, 0xA0},
	{ 71, 0xA9},
	{ 72, 0x4C},
	{ 73, 0x05},
	{ 74, 0x80},
	{ 75, 0xA7},
	{ 76, 0x10},
	{ 77, 0x00},
	{ 78, 0x40},
	{ 79, 0x6F},
	{ 80, 0x1C},
	{ 81, 0x05},
	{ 82, 0xA0},
	{ 83, 0xAC},
	{ 84, 0x18},
	{ 85, 0x05},
	{ 86, 0x60},
	{ 87, 0x65},
	{ 88, 0x5C},
	{ 89, 0x90},
	{ 90, 0x60},
	{ 91, 0x03},
	{ 92, 0x18},
	{ 93, 0x05},
	{ 94, 0x80},
	{ 95, 0x6B},
	{ 96, 0x1C},
	{ 97, 0x05},
	{ 98, 0xA0},
	{ 99, 0x69},
	{100, 0x4C},
	{101, 0x05},
	{102, 0x80},
	{103, 0x67},
	{104, 0x10},
	{105, 0x00},
	{106, 0x40},
	{107, 0xAE},
	{108, 0x1C},
	{109, 0x05},
	{110, 0xA0},
	{111, 0x6C},
	{112, 0x00},
	{113, 0x00},
	{114, 0x00},
	{115, 0x00},
	{116, 0x5C},
	{117, 0x90},
	{118, 0x40},
	{119, 0x03},
	{120, 0x18},
	{121, 0x05},
	{122, 0xC0},
	{123, 0xA7},
	{124, 0x1C},
	{125, 0x05},
	{126, 0xC0},
	{127, 0xAC},
	{  0, 0x12},
	{  8, 0x1C},
	{  9, 0x05},
	{ 10, 0xE0},
	{ 11, 0xA9},
	{ 12, 0x10},
	{ 13, 0x00},
	{ 14, 0x40},
	{ 15, 0x6E},
	{ 16, 0x00},
	{ 17, 0x00},
	{ 18, 0x00},
	{ 19, 0x00},
	{ 20, 0x5C},
	{ 21, 0x90},
	{ 22, 0x60},
	{ 23, 0x03},
	{ 24, 0x18},
	{ 25, 0x05},
	{ 26, 0xC0},
	{ 27, 0x67},
	{ 28, 0x1C},
	{ 29, 0x05},
	{ 30, 0xC0},
	{ 31, 0x6C},
	{ 32, 0x1C},
	{ 33, 0x05},
	{ 34, 0xE0},
	{ 35, 0x69},
	{ 36, 0x10},
	{ 37, 0x00},
	{ 38, 0x40},
	{ 39, 0xAD},
	{ 40, 0x5C},
	{ 41, 0x90},
	{ 42, 0x40},
	{ 43, 0x03},
	{ 44, 0x00},
	{ 45, 0x00},
	{ 46, 0x00},
	{ 47, 0x00},
	{ 48, 0x00},
	{ 49, 0x00},
	{ 50, 0x00},
	{ 51, 0x00},
	{ 52, 0x00},
	{ 53, 0x00},
	{ 54, 0x00},
	{ 55, 0x00},
	{ 56, 0x10},
	{ 57, 0x00},
	{ 58, 0x40},
	{ 59, 0x6D},
	{ 60, 0x00},
	{ 61, 0x00},
	{ 62, 0x00},
	{ 63, 0x00},
	{ 64, 0x02},
	{ 65, 0x00},
	{ 66, 0x00},
	{ 67, 0x00},
	{ 68, 0x00},
	{ 69, 0x00},
	{ 70, 0x00},
	{ 71, 0x00},
};
#define main44_miniDSP_D_reg_values_COEFF_START   0
#define main44_miniDSP_D_reg_values_COEFF_SIZE    672
#define main44_miniDSP_D_reg_values_INST_START    672
#define main44_miniDSP_D_reg_values_INST_SIZE     2124
